include config.gnu

oopsy:
	@echo Please select a target

install:
	( cd asmgen ; $(MAKE) -f makefile.gnu install )
	( cd chnhash ; $(MAKE) -f makefile.gnu install )

correct:
	( cd tests/collide  ; $(MAKE) -f makefile.gnu )
	( cd tests/correct  ; $(MAKE) -f makefile.gnu )
	( cd tests/collide  ; ./md5cmpc$(EXESUFFIX) )
	( cd tests/correct  ; ./md5$(EXESUFFIX) )
	( cd tests/correct  ; ./sha0$(EXESUFFIX) )
	( cd tests/correct  ; ./sha1$(EXESUFFIX) )
	( cd tests/correct  ; ./rmd128$(EXESUFFIX) )
	( cd tests/correct  ; ./rmd160$(EXESUFFIX) )

speed:
	( cd tests/speed ; $(MAKE)  -f makefile.gnu )
	( cd tests/speed ; ./md5s$(EXESUFFIX) )
	( cd tests/speed ; ./sha0s$(EXESUFFIX) )
	( cd tests/speed ; ./sha1s$(EXESUFFIX) )
	( cd tests/speed ; ./rmd128s$(EXESUFFIX) )
	( cd tests/speed ; ./rmd160s$(EXESUFFIX) )

clean:
	( cd asmgen ; make  -f makefile.gnu clean )
	( cd chnhash ; make  -f makefile.gnu clean )
	( cd lib ; make  -f makefile.gnu clean )
	( cd include ; make  -f makefile.gnu clean )
	( cd docs ; make  -f makefile.gnu clean )
	( cd tests/collide ; make  -f makefile.gnu clean )
	( cd tests/speed ; make  -f makefile.gnu clean )
	( cd tests/correct ; make  -f makefile.gnu clean )

distclean:
	( cd asmgen ; make  -f makefile.gnu distclean )
	( cd chnhash ; make  -f makefile.gnu distclean )
	( cd lib ; make  -f makefile.gnu distclean )
	( cd include ; make  -f makefile.gnu distclean )
	( cd docs ; make  -f makefile.gnu distclean )
	( cd tests/collide ; make  -f makefile.gnu distclean )
	( cd tests/speed ; make  -f makefile.gnu distclean )
	( cd tests/correct ; make  -f makefile.gnu distclean )
