#include "asm.h"
.text
.globl FUNCTION(RIPEMD160Transform)
.align ALIGN
FUNCTION(RIPEMD160Transform)
	pushl %ebp
	pushl %esi
	pushl %edi
	pushl %ebx
	movl 20(%esp), %eax
	movl 24(%esp), %edx
	subl $64, %esp
	movl (%edx), %edi
	movl 4(%edx), %ebp
	movl %edi, (%esp)
	movl %ebp, 4(%esp)
	movl 8(%edx), %edi
	movl 12(%edx), %ebp
	movl %edi, 8(%esp)
	movl %ebp, 12(%esp)
	movl 16(%edx), %edi
	movl 20(%edx), %ebp
	movl %edi, 16(%esp)
	movl %ebp, 20(%esp)
	movl 24(%edx), %edi
	movl 28(%edx), %ebp
	movl %edi, 24(%esp)
	movl %ebp, 28(%esp)
	movl 32(%edx), %edi
	movl 36(%edx), %ebp
	movl %edi, 32(%esp)
	movl %ebp, 36(%esp)
	movl 40(%edx), %edi
	movl 44(%edx), %ebp
	movl %edi, 40(%esp)
	movl %ebp, 44(%esp)
	movl 48(%edx), %edi
	movl 52(%edx), %ebp
	movl %edi, 48(%esp)
	movl %ebp, 52(%esp)
	movl 56(%edx), %edi
	movl 60(%edx), %ebp
	movl %edi, 56(%esp)
	movl %ebp, 60(%esp)
	movl 16(%eax), %edi
	movl 12(%eax), %edx
	movl 8(%eax), %ecx
	movl 4(%eax), %ebx
	movl (%eax), %eax
	pushl %edi
	pushl %edx
	pushl %ecx
	pushl %ebx
	pushl %eax
# left half
	movl %ecx, %ebp
	movl 20(%esp), %esi
# Subround 0
	xorl %edx, %ebp
	xorl %ebx, %ebp
	addl %esi, %eax
	roll $10, %ecx
	addl %ebp, %eax
	movl %ebx, %ebp
	roll $11, %eax
	movl 24(%esp), %esi
	addl %edi, %eax

# Subround 1
	xorl %ecx, %ebp
	addl %esi, %edi
	xorl %eax, %ebp
	movl 28(%esp), %esi
	roll $10, %ebx
	addl %ebp, %edi
	movl %eax, %ebp
	roll $14, %edi
	addl %edx, %edi

# Subround 2
	xorl %ebx, %ebp
	xorl %edi, %ebp
	addl %esi, %edx
	roll $10, %eax
	addl %ebp, %edx
	movl %edi, %ebp
	roll $15, %edx
	movl 32(%esp), %esi
	addl %ecx, %edx

# Subround 3
	xorl %eax, %ebp
	addl %esi, %ecx
	xorl %edx, %ebp
	movl 36(%esp), %esi
	roll $10, %edi
	addl %ebp, %ecx
	movl %edx, %ebp
	roll $12, %ecx
	addl %ebx, %ecx

# Subround 4
	xorl %edi, %ebp
	xorl %ecx, %ebp
	addl %esi, %ebx
	roll $10, %edx
	addl %ebp, %ebx
	movl %ecx, %ebp
	roll $5, %ebx
	movl 40(%esp), %esi
	addl %eax, %ebx

# Subround 5
	xorl %edx, %ebp
	addl %esi, %eax
	xorl %ebx, %ebp
	movl 44(%esp), %esi
	roll $10, %ecx
	addl %ebp, %eax
	movl %ebx, %ebp
	roll $8, %eax
	addl %edi, %eax

# Subround 6
	xorl %ecx, %ebp
	xorl %eax, %ebp
	addl %esi, %edi
	roll $10, %ebx
	addl %ebp, %edi
	movl %eax, %ebp
	roll $7, %edi
	movl 48(%esp), %esi
	addl %edx, %edi

# Subround 7
	xorl %ebx, %ebp
	addl %esi, %edx
	xorl %edi, %ebp
	movl 52(%esp), %esi
	roll $10, %eax
	addl %ebp, %edx
	movl %edi, %ebp
	roll $9, %edx
	addl %ecx, %edx

# Subround 8
	xorl %eax, %ebp
	xorl %edx, %ebp
	addl %esi, %ecx
	roll $10, %edi
	addl %ebp, %ecx
	movl %edx, %ebp
	roll $11, %ecx
	movl 56(%esp), %esi
	addl %ebx, %ecx

# Subround 9
	xorl %edi, %ebp
	addl %esi, %ebx
	xorl %ecx, %ebp
	movl 60(%esp), %esi
	roll $10, %edx
	addl %ebp, %ebx
	movl %ecx, %ebp
	roll $13, %ebx
	addl %eax, %ebx

# Subround 10
	xorl %edx, %ebp
	xorl %ebx, %ebp
	addl %esi, %eax
	roll $10, %ecx
	addl %ebp, %eax
	movl %ebx, %ebp
	roll $14, %eax
	movl 64(%esp), %esi
	addl %edi, %eax

# Subround 11
	xorl %ecx, %ebp
	addl %esi, %edi
	xorl %eax, %ebp
	movl 68(%esp), %esi
	roll $10, %ebx
	addl %ebp, %edi
	movl %eax, %ebp
	roll $15, %edi
	addl %edx, %edi

# Subround 12
	xorl %ebx, %ebp
	xorl %edi, %ebp
	addl %esi, %edx
	roll $10, %eax
	addl %ebp, %edx
	movl %edi, %ebp
	roll $6, %edx
	movl 72(%esp), %esi
	addl %ecx, %edx

# Subround 13
	xorl %eax, %ebp
	addl %esi, %ecx
	xorl %edx, %ebp
	movl 76(%esp), %esi
	roll $10, %edi
	addl %ebp, %ecx
	movl %edx, %ebp
	roll $7, %ecx
	addl %ebx, %ecx

# Subround 14
	xorl %edi, %ebp
	xorl %ecx, %ebp
	addl %esi, %ebx
	roll $10, %edx
	addl %ebp, %ebx
	movl %ecx, %ebp
	roll $9, %ebx
	movl 80(%esp), %esi
	addl %eax, %ebx

# Subround 15
	xorl %edx, %ebp
	addl %esi, %eax
	xorl %ebx, %ebp
	movl 48(%esp), %esi
	roll $10, %ecx
	addl %ebp, %eax
	movl %ebx, %ebp
	roll $8, %eax
	addl %edi, %eax

# Subround 16
	xorl %ecx, %ebp
	andl %eax, %ebp
	movl 48(%esp), %esi
	xorl %ecx, %ebp
	addl %esi, %edi
	roll $10, %ebx
	leal 1518500249(%edi,%ebp,1), %edi
	movl %eax, %ebp
	roll $7, %edi
	addl %edx, %edi

# Subround 17
	xorl %ebx, %ebp
	andl %edi, %ebp
	movl 36(%esp), %esi
	xorl %ebx, %ebp
	addl %esi, %edx
	roll $10, %eax
	leal 1518500249(%edx,%ebp,1), %edx
	movl %edi, %ebp
	roll $6, %edx
	addl %ecx, %edx

# Subround 18
	xorl %eax, %ebp
	andl %edx, %ebp
	movl 72(%esp), %esi
	xorl %eax, %ebp
	addl %esi, %ecx
	roll $10, %edi
	leal 1518500249(%ecx,%ebp,1), %ecx
	movl %edx, %ebp
	roll $8, %ecx
	addl %ebx, %ecx

# Subround 19
	xorl %edi, %ebp
	andl %ecx, %ebp
	movl 24(%esp), %esi
	xorl %edi, %ebp
	addl %esi, %ebx
	roll $10, %edx
	leal 1518500249(%ebx,%ebp,1), %ebx
	movl %ecx, %ebp
	roll $13, %ebx
	addl %eax, %ebx

# Subround 20
	xorl %edx, %ebp
	andl %ebx, %ebp
	movl 60(%esp), %esi
	xorl %edx, %ebp
	addl %esi, %eax
	roll $10, %ecx
	leal 1518500249(%eax,%ebp,1), %eax
	movl %ebx, %ebp
	roll $11, %eax
	addl %edi, %eax

# Subround 21
	xorl %ecx, %ebp
	andl %eax, %ebp
	movl 44(%esp), %esi
	xorl %ecx, %ebp
	addl %esi, %edi
	roll $10, %ebx
	leal 1518500249(%edi,%ebp,1), %edi
	movl %eax, %ebp
	roll $9, %edi
	addl %edx, %edi

# Subround 22
	xorl %ebx, %ebp
	andl %edi, %ebp
	movl 80(%esp), %esi
	xorl %ebx, %ebp
	addl %esi, %edx
	roll $10, %eax
	leal 1518500249(%edx,%ebp,1), %edx
	movl %edi, %ebp
	roll $7, %edx
	addl %ecx, %edx

# Subround 23
	xorl %eax, %ebp
	andl %edx, %ebp
	movl 32(%esp), %esi
	xorl %eax, %ebp
	addl %esi, %ecx
	roll $10, %edi
	leal 1518500249(%ecx,%ebp,1), %ecx
	movl %edx, %ebp
	roll $15, %ecx
	addl %ebx, %ecx

# Subround 24
	xorl %edi, %ebp
	andl %ecx, %ebp
	movl 68(%esp), %esi
	xorl %edi, %ebp
	addl %esi, %ebx
	roll $10, %edx
	leal 1518500249(%ebx,%ebp,1), %ebx
	movl %ecx, %ebp
	roll $7, %ebx
	addl %eax, %ebx

# Subround 25
	xorl %edx, %ebp
	andl %ebx, %ebp
	movl 20(%esp), %esi
	xorl %edx, %ebp
	addl %esi, %eax
	roll $10, %ecx
	leal 1518500249(%eax,%ebp,1), %eax
	movl %ebx, %ebp
	roll $12, %eax
	addl %edi, %eax

# Subround 26
	xorl %ecx, %ebp
	andl %eax, %ebp
	movl 56(%esp), %esi
	xorl %ecx, %ebp
	addl %esi, %edi
	roll $10, %ebx
	leal 1518500249(%edi,%ebp,1), %edi
	movl %eax, %ebp
	roll $15, %edi
	addl %edx, %edi

# Subround 27
	xorl %ebx, %ebp
	andl %edi, %ebp
	movl 40(%esp), %esi
	xorl %ebx, %ebp
	addl %esi, %edx
	roll $10, %eax
	leal 1518500249(%edx,%ebp,1), %edx
	movl %edi, %ebp
	roll $9, %edx
	addl %ecx, %edx

# Subround 28
	xorl %eax, %ebp
	andl %edx, %ebp
	movl 28(%esp), %esi
	xorl %eax, %ebp
	addl %esi, %ecx
	roll $10, %edi
	leal 1518500249(%ecx,%ebp,1), %ecx
	movl %edx, %ebp
	roll $11, %ecx
	addl %ebx, %ecx

# Subround 29
	xorl %edi, %ebp
	andl %ecx, %ebp
	movl 76(%esp), %esi
	xorl %edi, %ebp
	addl %esi, %ebx
	roll $10, %edx
	leal 1518500249(%ebx,%ebp,1), %ebx
	movl %ecx, %ebp
	roll $7, %ebx
	addl %eax, %ebx

# Subround 30
	xorl %edx, %ebp
	andl %ebx, %ebp
	movl 64(%esp), %esi
	xorl %edx, %ebp
	addl %esi, %eax
	roll $10, %ecx
	leal 1518500249(%eax,%ebp,1), %eax
	movl %ebx, %ebp
	roll $13, %eax
	addl %edi, %eax

# Subround 31
	xorl %ecx, %ebp
	andl %eax, %ebp
	movl 52(%esp), %esi
	xorl %ecx, %ebp
	addl %esi, %edi
	roll $10, %ebx
	leal 1518500249(%edi,%ebp,1), %edi
	movl %eax, %ebp
	roll $12, %edi
	addl %edx, %edi

# Subround 32
	xorl $-1, %ebp
	orl %edi, %ebp
	movl 32(%esp), %esi
	xorl %ebx, %ebp
	addl %esi, %edx
	roll $10, %eax
	leal 1859775393(%edx,%ebp,1), %edx
	movl %edi, %ebp
	roll $11, %edx
	addl %ecx, %edx

# Subround 33
	xorl $-1, %ebp
	orl %edx, %ebp
	movl 60(%esp), %esi
	xorl %eax, %ebp
	addl %esi, %ecx
	roll $10, %edi
	leal 1859775393(%ecx,%ebp,1), %ecx
	movl %edx, %ebp
	roll $13, %ecx
	addl %ebx, %ecx

# Subround 34
	xorl $-1, %ebp
	orl %ecx, %ebp
	movl 76(%esp), %esi
	xorl %edi, %ebp
	addl %esi, %ebx
	roll $10, %edx
	leal 1859775393(%ebx,%ebp,1), %ebx
	movl %ecx, %ebp
	roll $6, %ebx
	addl %eax, %ebx

# Subround 35
	xorl $-1, %ebp
	orl %ebx, %ebp
	movl 36(%esp), %esi
	xorl %edx, %ebp
	addl %esi, %eax
	roll $10, %ecx
	leal 1859775393(%eax,%ebp,1), %eax
	movl %ebx, %ebp
	roll $7, %eax
	addl %edi, %eax

# Subround 36
	xorl $-1, %ebp
	orl %eax, %ebp
	movl 56(%esp), %esi
	xorl %ecx, %ebp
	addl %esi, %edi
	roll $10, %ebx
	leal 1859775393(%edi,%ebp,1), %edi
	movl %eax, %ebp
	roll $14, %edi
	addl %edx, %edi

# Subround 37
	xorl $-1, %ebp
	orl %edi, %ebp
	movl 80(%esp), %esi
	xorl %ebx, %ebp
	addl %esi, %edx
	roll $10, %eax
	leal 1859775393(%edx,%ebp,1), %edx
	movl %edi, %ebp
	roll $9, %edx
	addl %ecx, %edx

# Subround 38
	xorl $-1, %ebp
	orl %edx, %ebp
	movl 52(%esp), %esi
	xorl %eax, %ebp
	addl %esi, %ecx
	roll $10, %edi
	leal 1859775393(%ecx,%ebp,1), %ecx
	movl %edx, %ebp
	roll $13, %ecx
	addl %ebx, %ecx

# Subround 39
	xorl $-1, %ebp
	orl %ecx, %ebp
	movl 24(%esp), %esi
	xorl %edi, %ebp
	addl %esi, %ebx
	roll $10, %edx
	leal 1859775393(%ebx,%ebp,1), %ebx
	movl %ecx, %ebp
	roll $15, %ebx
	addl %eax, %ebx

# Subround 40
	xorl $-1, %ebp
	orl %ebx, %ebp
	movl 28(%esp), %esi
	xorl %edx, %ebp
	addl %esi, %eax
	roll $10, %ecx
	leal 1859775393(%eax,%ebp,1), %eax
	movl %ebx, %ebp
	roll $14, %eax
	addl %edi, %eax

# Subround 41
	xorl $-1, %ebp
	orl %eax, %ebp
	movl 48(%esp), %esi
	xorl %ecx, %ebp
	addl %esi, %edi
	roll $10, %ebx
	leal 1859775393(%edi,%ebp,1), %edi
	movl %eax, %ebp
	roll $8, %edi
	addl %edx, %edi

# Subround 42
	xorl $-1, %ebp
	orl %edi, %ebp
	movl 20(%esp), %esi
	xorl %ebx, %ebp
	addl %esi, %edx
	roll $10, %eax
	leal 1859775393(%edx,%ebp,1), %edx
	movl %edi, %ebp
	roll $13, %edx
	addl %ecx, %edx

# Subround 43
	xorl $-1, %ebp
	orl %edx, %ebp
	movl 44(%esp), %esi
	xorl %eax, %ebp
	addl %esi, %ecx
	roll $10, %edi
	leal 1859775393(%ecx,%ebp,1), %ecx
	movl %edx, %ebp
	roll $6, %ecx
	addl %ebx, %ecx

# Subround 44
	xorl $-1, %ebp
	orl %ecx, %ebp
	movl 72(%esp), %esi
	xorl %edi, %ebp
	addl %esi, %ebx
	roll $10, %edx
	leal 1859775393(%ebx,%ebp,1), %ebx
	movl %ecx, %ebp
	roll $5, %ebx
	addl %eax, %ebx

# Subround 45
	xorl $-1, %ebp
	orl %ebx, %ebp
	movl 64(%esp), %esi
	xorl %edx, %ebp
	addl %esi, %eax
	roll $10, %ecx
	leal 1859775393(%eax,%ebp,1), %eax
	movl %ebx, %ebp
	roll $12, %eax
	addl %edi, %eax

# Subround 46
	xorl $-1, %ebp
	orl %eax, %ebp
	movl 40(%esp), %esi
	xorl %ecx, %ebp
	addl %esi, %edi
	roll $10, %ebx
	leal 1859775393(%edi,%ebp,1), %edi
	movl %eax, %ebp
	roll $7, %edi
	addl %edx, %edi

# Subround 47
	xorl $-1, %ebp
	orl %edi, %ebp
	movl 68(%esp), %esi
	xorl %ebx, %ebp
	addl %esi, %edx
	roll $10, %eax
	leal 1859775393(%edx,%ebp,1), %edx
	movl %edi, %ebp
	roll $5, %edx
	addl %ecx, %edx

# Subround 48
	xorl %edx, %ebp
	andl %eax, %ebp
	movl 24(%esp), %esi
	xorl %edi, %ebp
	addl %esi, %ecx
	roll $10, %edi
	leal -1894007588(%ecx,%ebp,1), %ecx
	movl %edx, %ebp
	roll $11, %ecx
	addl %ebx, %ecx

# Subround 49
	xorl %ecx, %ebp
	andl %edi, %ebp
	movl 56(%esp), %esi
	xorl %edx, %ebp
	addl %esi, %ebx
	roll $10, %edx
	leal -1894007588(%ebx,%ebp,1), %ebx
	movl %ecx, %ebp
	roll $12, %ebx
	addl %eax, %ebx

# Subround 50
	xorl %ebx, %ebp
	andl %edx, %ebp
	movl 64(%esp), %esi
	xorl %ecx, %ebp
	addl %esi, %eax
	roll $10, %ecx
	leal -1894007588(%eax,%ebp,1), %eax
	movl %ebx, %ebp
	roll $14, %eax
	addl %edi, %eax

# Subround 51
	xorl %eax, %ebp
	andl %ecx, %ebp
	movl 60(%esp), %esi
	xorl %ebx, %ebp
	addl %esi, %edi
	roll $10, %ebx
	leal -1894007588(%edi,%ebp,1), %edi
	movl %eax, %ebp
	roll $15, %edi
	addl %edx, %edi

# Subround 52
	xorl %edi, %ebp
	andl %ebx, %ebp
	movl 20(%esp), %esi
	xorl %eax, %ebp
	addl %esi, %edx
	roll $10, %eax
	leal -1894007588(%edx,%ebp,1), %edx
	movl %edi, %ebp
	roll $14, %edx
	addl %ecx, %edx

# Subround 53
	xorl %edx, %ebp
	andl %eax, %ebp
	movl 52(%esp), %esi
	xorl %edi, %ebp
	addl %esi, %ecx
	roll $10, %edi
	leal -1894007588(%ecx,%ebp,1), %ecx
	movl %edx, %ebp
	roll $15, %ecx
	addl %ebx, %ecx

# Subround 54
	xorl %ecx, %ebp
	andl %edi, %ebp
	movl 68(%esp), %esi
	xorl %edx, %ebp
	addl %esi, %ebx
	roll $10, %edx
	leal -1894007588(%ebx,%ebp,1), %ebx
	movl %ecx, %ebp
	roll $9, %ebx
	addl %eax, %ebx

# Subround 55
	xorl %ebx, %ebp
	andl %edx, %ebp
	movl 36(%esp), %esi
	xorl %ecx, %ebp
	addl %esi, %eax
	roll $10, %ecx
	leal -1894007588(%eax,%ebp,1), %eax
	movl %ebx, %ebp
	roll $8, %eax
	addl %edi, %eax

# Subround 56
	xorl %eax, %ebp
	andl %ecx, %ebp
	movl 72(%esp), %esi
	xorl %ebx, %ebp
	addl %esi, %edi
	roll $10, %ebx
	leal -1894007588(%edi,%ebp,1), %edi
	movl %eax, %ebp
	roll $9, %edi
	addl %edx, %edi

# Subround 57
	xorl %edi, %ebp
	andl %ebx, %ebp
	movl 32(%esp), %esi
	xorl %eax, %ebp
	addl %esi, %edx
	roll $10, %eax
	leal -1894007588(%edx,%ebp,1), %edx
	movl %edi, %ebp
	roll $14, %edx
	addl %ecx, %edx

# Subround 58
	xorl %edx, %ebp
	andl %eax, %ebp
	movl 48(%esp), %esi
	xorl %edi, %ebp
	addl %esi, %ecx
	roll $10, %edi
	leal -1894007588(%ecx,%ebp,1), %ecx
	movl %edx, %ebp
	roll $5, %ecx
	addl %ebx, %ecx

# Subround 59
	xorl %ecx, %ebp
	andl %edi, %ebp
	movl 80(%esp), %esi
	xorl %edx, %ebp
	addl %esi, %ebx
	roll $10, %edx
	leal -1894007588(%ebx,%ebp,1), %ebx
	movl %ecx, %ebp
	roll $6, %ebx
	addl %eax, %ebx

# Subround 60
	xorl %ebx, %ebp
	andl %edx, %ebp
	movl 76(%esp), %esi
	xorl %ecx, %ebp
	addl %esi, %eax
	roll $10, %ecx
	leal -1894007588(%eax,%ebp,1), %eax
	movl %ebx, %ebp
	roll $8, %eax
	addl %edi, %eax

# Subround 61
	xorl %eax, %ebp
	andl %ecx, %ebp
	movl 40(%esp), %esi
	xorl %ebx, %ebp
	addl %esi, %edi
	roll $10, %ebx
	leal -1894007588(%edi,%ebp,1), %edi
	movl %eax, %ebp
	roll $6, %edi
	addl %edx, %edi

# Subround 62
	xorl %edi, %ebp
	andl %ebx, %ebp
	movl 44(%esp), %esi
	xorl %eax, %ebp
	addl %esi, %edx
	roll $10, %eax
	leal -1894007588(%edx,%ebp,1), %edx
	movl %edi, %ebp
	roll $5, %edx
	addl %ecx, %edx

# Subround 63
	xorl %edx, %ebp
	andl %eax, %ebp
	movl 28(%esp), %esi
	xorl %edi, %ebp
	addl %esi, %ecx
	roll $10, %edi
	leal -1894007588(%ecx,%ebp,1), %ecx
	movl %edx, %ebp
	roll $12, %ecx
	addl %ebx, %ecx

	movl %edi, %ebp
	nop
# Subround 64
	xorl $-1, %ebp
	orl %edx, %ebp
	movl 36(%esp), %esi
	xorl %ecx, %ebp
	addl %esi, %ebx
	roll $10, %edx
	leal -1454113458(%ebx,%ebp,1), %ebx
	movl %edx, %ebp
	roll $9, %ebx
	addl %eax, %ebx

# Subround 65
	xorl $-1, %ebp
	orl %ecx, %ebp
	movl 20(%esp), %esi
	xorl %ebx, %ebp
	addl %esi, %eax
	roll $10, %ecx
	leal -1454113458(%eax,%ebp,1), %eax
	movl %ecx, %ebp
	roll $15, %eax
	addl %edi, %eax

# Subround 66
	xorl $-1, %ebp
	orl %ebx, %ebp
	movl 40(%esp), %esi
	xorl %eax, %ebp
	addl %esi, %edi
	roll $10, %ebx
	leal -1454113458(%edi,%ebp,1), %edi
	movl %ebx, %ebp
	roll $5, %edi
	addl %edx, %edi

# Subround 67
	xorl $-1, %ebp
	orl %eax, %ebp
	movl 56(%esp), %esi
	xorl %edi, %ebp
	addl %esi, %edx
	roll $10, %eax
	leal -1454113458(%edx,%ebp,1), %edx
	movl %eax, %ebp
	roll $11, %edx
	addl %ecx, %edx

# Subround 68
	xorl $-1, %ebp
	orl %edi, %ebp
	movl 48(%esp), %esi
	xorl %edx, %ebp
	addl %esi, %ecx
	roll $10, %edi
	leal -1454113458(%ecx,%ebp,1), %ecx
	movl %edi, %ebp
	roll $6, %ecx
	addl %ebx, %ecx

# Subround 69
	xorl $-1, %ebp
	orl %edx, %ebp
	movl 68(%esp), %esi
	xorl %ecx, %ebp
	addl %esi, %ebx
	roll $10, %edx
	leal -1454113458(%ebx,%ebp,1), %ebx
	movl %edx, %ebp
	roll $8, %ebx
	addl %eax, %ebx

# Subround 70
	xorl $-1, %ebp
	orl %ecx, %ebp
	movl 28(%esp), %esi
	xorl %ebx, %ebp
	addl %esi, %eax
	roll $10, %ecx
	leal -1454113458(%eax,%ebp,1), %eax
	movl %ecx, %ebp
	roll $13, %eax
	addl %edi, %eax

# Subround 71
	xorl $-1, %ebp
	orl %ebx, %ebp
	movl 60(%esp), %esi
	xorl %eax, %ebp
	addl %esi, %edi
	roll $10, %ebx
	leal -1454113458(%edi,%ebp,1), %edi
	movl %ebx, %ebp
	roll $12, %edi
	addl %edx, %edi

# Subround 72
	xorl $-1, %ebp
	orl %eax, %ebp
	movl 76(%esp), %esi
	xorl %edi, %ebp
	addl %esi, %edx
	roll $10, %eax
	leal -1454113458(%edx,%ebp,1), %edx
	movl %eax, %ebp
	roll $5, %edx
	addl %ecx, %edx

# Subround 73
	xorl $-1, %ebp
	orl %edi, %ebp
	movl 24(%esp), %esi
	xorl %edx, %ebp
	addl %esi, %ecx
	roll $10, %edi
	leal -1454113458(%ecx,%ebp,1), %ecx
	movl %edi, %ebp
	roll $12, %ecx
	addl %ebx, %ecx

# Subround 74
	xorl $-1, %ebp
	orl %edx, %ebp
	movl 32(%esp), %esi
	xorl %ecx, %ebp
	addl %esi, %ebx
	roll $10, %edx
	leal -1454113458(%ebx,%ebp,1), %ebx
	movl %edx, %ebp
	roll $13, %ebx
	addl %eax, %ebx

# Subround 75
	xorl $-1, %ebp
	orl %ecx, %ebp
	movl 52(%esp), %esi
	xorl %ebx, %ebp
	addl %esi, %eax
	roll $10, %ecx
	leal -1454113458(%eax,%ebp,1), %eax
	movl %ecx, %ebp
	roll $14, %eax
	addl %edi, %eax

# Subround 76
	xorl $-1, %ebp
	orl %ebx, %ebp
	movl 64(%esp), %esi
	xorl %eax, %ebp
	addl %esi, %edi
	roll $10, %ebx
	leal -1454113458(%edi,%ebp,1), %edi
	movl %ebx, %ebp
	roll $11, %edi
	addl %edx, %edi

# Subround 77
	xorl $-1, %ebp
	orl %eax, %ebp
	movl 44(%esp), %esi
	xorl %edi, %ebp
	addl %esi, %edx
	roll $10, %eax
	leal -1454113458(%edx,%ebp,1), %edx
	movl %eax, %ebp
	roll $8, %edx
	addl %ecx, %edx

# Subround 78
	xorl $-1, %ebp
	orl %edi, %ebp
	movl 80(%esp), %esi
	xorl %edx, %ebp
	addl %esi, %ecx
	roll $10, %edi
	leal -1454113458(%ecx,%ebp,1), %ecx
	movl %edi, %ebp
	roll $5, %ecx
	addl %ebx, %ecx

# Subround 79
	xorl $-1, %ebp
	orl %edx, %ebp
	movl 72(%esp), %esi
	xorl %ecx, %ebp
	addl %esi, %ebx
	roll $10, %edx
	leal -1454113458(%ebx,%ebp,1), %ebx
	movl %edx, %ebp
	roll $6, %ebx
	addl %eax, %ebx

# save left result
	pushl %edi
	pushl %edx
	pushl %ecx
	pushl %ebx
	pushl %eax
# reloading chain variables
	movl 36(%esp), %edi
	movl 32(%esp), %edx
	movl 28(%esp), %ecx
	movl 24(%esp), %ebx
	movl 20(%esp), %eax
# right half
	movl %edx, %ebp
# Subround 0
	xorl $-1, %ebp
	orl %ecx, %ebp
	movl 60(%esp), %esi
	xorl %ebx, %ebp
	addl %esi, %eax
	roll $10, %ecx
	leal 1352829926(%eax,%ebp,1), %eax
	movl %ecx, %ebp
	roll $8, %eax
	addl %edi, %eax

# Subround 1
	xorl $-1, %ebp
	orl %ebx, %ebp
	movl 96(%esp), %esi
	xorl %eax, %ebp
	addl %esi, %edi
	roll $10, %ebx
	leal 1352829926(%edi,%ebp,1), %edi
	movl %ebx, %ebp
	roll $9, %edi
	addl %edx, %edi

# Subround 2
	xorl $-1, %ebp
	orl %eax, %ebp
	movl 68(%esp), %esi
	xorl %edi, %ebp
	addl %esi, %edx
	roll $10, %eax
	leal 1352829926(%edx,%ebp,1), %edx
	movl %eax, %ebp
	roll $9, %edx
	addl %ecx, %edx

# Subround 3
	xorl $-1, %ebp
	orl %edi, %ebp
	movl 40(%esp), %esi
	xorl %edx, %ebp
	addl %esi, %ecx
	roll $10, %edi
	leal 1352829926(%ecx,%ebp,1), %ecx
	movl %edi, %ebp
	roll $11, %ecx
	addl %ebx, %ecx

# Subround 4
	xorl $-1, %ebp
	orl %edx, %ebp
	movl 76(%esp), %esi
	xorl %ecx, %ebp
	addl %esi, %ebx
	roll $10, %edx
	leal 1352829926(%ebx,%ebp,1), %ebx
	movl %edx, %ebp
	roll $13, %ebx
	addl %eax, %ebx

# Subround 5
	xorl $-1, %ebp
	orl %ecx, %ebp
	movl 48(%esp), %esi
	xorl %ebx, %ebp
	addl %esi, %eax
	roll $10, %ecx
	leal 1352829926(%eax,%ebp,1), %eax
	movl %ecx, %ebp
	roll $15, %eax
	addl %edi, %eax

# Subround 6
	xorl $-1, %ebp
	orl %ebx, %ebp
	movl 84(%esp), %esi
	xorl %eax, %ebp
	addl %esi, %edi
	roll $10, %ebx
	leal 1352829926(%edi,%ebp,1), %edi
	movl %ebx, %ebp
	roll $15, %edi
	addl %edx, %edi

# Subround 7
	xorl $-1, %ebp
	orl %eax, %ebp
	movl 56(%esp), %esi
	xorl %edi, %ebp
	addl %esi, %edx
	roll $10, %eax
	leal 1352829926(%edx,%ebp,1), %edx
	movl %eax, %ebp
	roll $5, %edx
	addl %ecx, %edx

# Subround 8
	xorl $-1, %ebp
	orl %edi, %ebp
	movl 92(%esp), %esi
	xorl %edx, %ebp
	addl %esi, %ecx
	roll $10, %edi
	leal 1352829926(%ecx,%ebp,1), %ecx
	movl %edi, %ebp
	roll $7, %ecx
	addl %ebx, %ecx

# Subround 9
	xorl $-1, %ebp
	orl %edx, %ebp
	movl 64(%esp), %esi
	xorl %ecx, %ebp
	addl %esi, %ebx
	roll $10, %edx
	leal 1352829926(%ebx,%ebp,1), %ebx
	movl %edx, %ebp
	roll $7, %ebx
	addl %eax, %ebx

# Subround 10
	xorl $-1, %ebp
	orl %ecx, %ebp
	movl 100(%esp), %esi
	xorl %ebx, %ebp
	addl %esi, %eax
	roll $10, %ecx
	leal 1352829926(%eax,%ebp,1), %eax
	movl %ecx, %ebp
	roll $8, %eax
	addl %edi, %eax

# Subround 11
	xorl $-1, %ebp
	orl %ebx, %ebp
	movl 72(%esp), %esi
	xorl %eax, %ebp
	addl %esi, %edi
	roll $10, %ebx
	leal 1352829926(%edi,%ebp,1), %edi
	movl %ebx, %ebp
	roll $11, %edi
	addl %edx, %edi

# Subround 12
	xorl $-1, %ebp
	orl %eax, %ebp
	movl 44(%esp), %esi
	xorl %edi, %ebp
	addl %esi, %edx
	roll $10, %eax
	leal 1352829926(%edx,%ebp,1), %edx
	movl %eax, %ebp
	roll $14, %edx
	addl %ecx, %edx

# Subround 13
	xorl $-1, %ebp
	orl %edi, %ebp
	movl 80(%esp), %esi
	xorl %edx, %ebp
	addl %esi, %ecx
	roll $10, %edi
	leal 1352829926(%ecx,%ebp,1), %ecx
	movl %edi, %ebp
	roll $14, %ecx
	addl %ebx, %ecx

# Subround 14
	xorl $-1, %ebp
	orl %edx, %ebp
	movl 52(%esp), %esi
	xorl %ecx, %ebp
	addl %esi, %ebx
	roll $10, %edx
	leal 1352829926(%ebx,%ebp,1), %ebx
	movl %edx, %ebp
	roll $12, %ebx
	addl %eax, %ebx

# Subround 15
	xorl $-1, %ebp
	orl %ecx, %ebp
	movl 88(%esp), %esi
	xorl %ebx, %ebp
	addl %esi, %eax
	roll $10, %ecx
	leal 1352829926(%eax,%ebp,1), %eax
	movl %ecx, %ebp
	roll $6, %eax
	addl %edi, %eax

	movl %ebx, %ebp
	nop
# Subround 16
	xorl %eax, %ebp
	andl %ecx, %ebp
	movl 64(%esp), %esi
	xorl %ebx, %ebp
	addl %esi, %edi
	roll $10, %ebx
	leal 1548603684(%edi,%ebp,1), %edi
	movl %eax, %ebp
	roll $9, %edi
	addl %edx, %edi

# Subround 17
	xorl %edi, %ebp
	andl %ebx, %ebp
	movl 84(%esp), %esi
	xorl %eax, %ebp
	addl %esi, %edx
	roll $10, %eax
	leal 1548603684(%edx,%ebp,1), %edx
	movl %edi, %ebp
	roll $13, %edx
	addl %ecx, %edx

# Subround 18
	xorl %edx, %ebp
	andl %eax, %ebp
	movl 52(%esp), %esi
	xorl %edi, %ebp
	addl %esi, %ecx
	roll $10, %edi
	leal 1548603684(%ecx,%ebp,1), %ecx
	movl %edx, %ebp
	roll $15, %ecx
	addl %ebx, %ecx

# Subround 19
	xorl %ecx, %ebp
	andl %edi, %ebp
	movl 68(%esp), %esi
	xorl %edx, %ebp
	addl %esi, %ebx
	roll $10, %edx
	leal 1548603684(%ebx,%ebp,1), %ebx
	movl %ecx, %ebp
	roll $7, %ebx
	addl %eax, %ebx

# Subround 20
	xorl %ebx, %ebp
	andl %edx, %ebp
	movl 40(%esp), %esi
	xorl %ecx, %ebp
	addl %esi, %eax
	roll $10, %ecx
	leal 1548603684(%eax,%ebp,1), %eax
	movl %ebx, %ebp
	roll $12, %eax
	addl %edi, %eax

# Subround 21
	xorl %eax, %ebp
	andl %ecx, %ebp
	movl 92(%esp), %esi
	xorl %ebx, %ebp
	addl %esi, %edi
	roll $10, %ebx
	leal 1548603684(%edi,%ebp,1), %edi
	movl %eax, %ebp
	roll $8, %edi
	addl %edx, %edi

# Subround 22
	xorl %edi, %ebp
	andl %ebx, %ebp
	movl 60(%esp), %esi
	xorl %eax, %ebp
	addl %esi, %edx
	roll $10, %eax
	leal 1548603684(%edx,%ebp,1), %edx
	movl %edi, %ebp
	roll $9, %edx
	addl %ecx, %edx

# Subround 23
	xorl %edx, %ebp
	andl %eax, %ebp
	movl 80(%esp), %esi
	xorl %edi, %ebp
	addl %esi, %ecx
	roll $10, %edi
	leal 1548603684(%ecx,%ebp,1), %ecx
	movl %edx, %ebp
	roll $11, %ecx
	addl %ebx, %ecx

# Subround 24
	xorl %ecx, %ebp
	andl %edi, %ebp
	movl 96(%esp), %esi
	xorl %edx, %ebp
	addl %esi, %ebx
	roll $10, %edx
	leal 1548603684(%ebx,%ebp,1), %ebx
	movl %ecx, %ebp
	roll $7, %ebx
	addl %eax, %ebx

# Subround 25
	xorl %ebx, %ebp
	andl %edx, %ebp
	movl 100(%esp), %esi
	xorl %ecx, %ebp
	addl %esi, %eax
	roll $10, %ecx
	leal 1548603684(%eax,%ebp,1), %eax
	movl %ebx, %ebp
	roll $7, %eax
	addl %edi, %eax

# Subround 26
	xorl %eax, %ebp
	andl %ecx, %ebp
	movl 72(%esp), %esi
	xorl %ebx, %ebp
	addl %esi, %edi
	roll $10, %ebx
	leal 1548603684(%edi,%ebp,1), %edi
	movl %eax, %ebp
	roll $12, %edi
	addl %edx, %edi

# Subround 27
	xorl %edi, %ebp
	andl %ebx, %ebp
	movl 88(%esp), %esi
	xorl %eax, %ebp
	addl %esi, %edx
	roll $10, %eax
	leal 1548603684(%edx,%ebp,1), %edx
	movl %edi, %ebp
	roll $7, %edx
	addl %ecx, %edx

# Subround 28
	xorl %edx, %ebp
	andl %eax, %ebp
	movl 56(%esp), %esi
	xorl %edi, %ebp
	addl %esi, %ecx
	roll $10, %edi
	leal 1548603684(%ecx,%ebp,1), %ecx
	movl %edx, %ebp
	roll $6, %ecx
	addl %ebx, %ecx

# Subround 29
	xorl %ecx, %ebp
	andl %edi, %ebp
	movl 76(%esp), %esi
	xorl %edx, %ebp
	addl %esi, %ebx
	roll $10, %edx
	leal 1548603684(%ebx,%ebp,1), %ebx
	movl %ecx, %ebp
	roll $15, %ebx
	addl %eax, %ebx

# Subround 30
	xorl %ebx, %ebp
	andl %edx, %ebp
	movl 44(%esp), %esi
	xorl %ecx, %ebp
	addl %esi, %eax
	roll $10, %ecx
	leal 1548603684(%eax,%ebp,1), %eax
	movl %ebx, %ebp
	roll $13, %eax
	addl %edi, %eax

# Subround 31
	xorl %eax, %ebp
	andl %ecx, %ebp
	movl 48(%esp), %esi
	xorl %ebx, %ebp
	addl %esi, %edi
	roll $10, %ebx
	leal 1548603684(%edi,%ebp,1), %edi
	movl %eax, %ebp
	roll $11, %edi
	addl %edx, %edi

# Subround 32
	xorl $-1, %ebp
	orl %edi, %ebp
	movl 100(%esp), %esi
	xorl %ebx, %ebp
	addl %esi, %edx
	roll $10, %eax
	leal 1836072691(%edx,%ebp,1), %edx
	movl %edi, %ebp
	roll $9, %edx
	addl %ecx, %edx

# Subround 33
	xorl $-1, %ebp
	orl %edx, %ebp
	movl 60(%esp), %esi
	xorl %eax, %ebp
	addl %esi, %ecx
	roll $10, %edi
	leal 1836072691(%ecx,%ebp,1), %ecx
	movl %edx, %ebp
	roll $7, %ecx
	addl %ebx, %ecx

# Subround 34
	xorl $-1, %ebp
	orl %ecx, %ebp
	movl 44(%esp), %esi
	xorl %edi, %ebp
	addl %esi, %ebx
	roll $10, %edx
	leal 1836072691(%ebx,%ebp,1), %ebx
	movl %ecx, %ebp
	roll $15, %ebx
	addl %eax, %ebx

# Subround 35
	xorl $-1, %ebp
	orl %ebx, %ebp
	movl 52(%esp), %esi
	xorl %edx, %ebp
	addl %esi, %eax
	roll $10, %ecx
	leal 1836072691(%eax,%ebp,1), %eax
	movl %ebx, %ebp
	roll $11, %eax
	addl %edi, %eax

# Subround 36
	xorl $-1, %ebp
	orl %eax, %ebp
	movl 68(%esp), %esi
	xorl %ecx, %ebp
	addl %esi, %edi
	roll $10, %ebx
	leal 1836072691(%edi,%ebp,1), %edi
	movl %eax, %ebp
	roll $8, %edi
	addl %edx, %edi

# Subround 37
	xorl $-1, %ebp
	orl %edi, %ebp
	movl 96(%esp), %esi
	xorl %ebx, %ebp
	addl %esi, %edx
	roll $10, %eax
	leal 1836072691(%edx,%ebp,1), %edx
	movl %edi, %ebp
	roll $6, %edx
	addl %ecx, %edx

# Subround 38
	xorl $-1, %ebp
	orl %edx, %ebp
	movl 64(%esp), %esi
	xorl %eax, %ebp
	addl %esi, %ecx
	roll $10, %edi
	leal 1836072691(%ecx,%ebp,1), %ecx
	movl %edx, %ebp
	roll $6, %ecx
	addl %ebx, %ecx

# Subround 39
	xorl $-1, %ebp
	orl %ecx, %ebp
	movl 76(%esp), %esi
	xorl %edi, %ebp
	addl %esi, %ebx
	roll $10, %edx
	leal 1836072691(%ebx,%ebp,1), %ebx
	movl %ecx, %ebp
	roll $14, %ebx
	addl %eax, %ebx

# Subround 40
	xorl $-1, %ebp
	orl %ebx, %ebp
	movl 84(%esp), %esi
	xorl %edx, %ebp
	addl %esi, %eax
	roll $10, %ecx
	leal 1836072691(%eax,%ebp,1), %eax
	movl %ebx, %ebp
	roll $12, %eax
	addl %edi, %eax

# Subround 41
	xorl $-1, %ebp
	orl %eax, %ebp
	movl 72(%esp), %esi
	xorl %ecx, %ebp
	addl %esi, %edi
	roll $10, %ebx
	leal 1836072691(%edi,%ebp,1), %edi
	movl %eax, %ebp
	roll $13, %edi
	addl %edx, %edi

# Subround 42
	xorl $-1, %ebp
	orl %edi, %ebp
	movl 88(%esp), %esi
	xorl %ebx, %ebp
	addl %esi, %edx
	roll $10, %eax
	leal 1836072691(%edx,%ebp,1), %edx
	movl %edi, %ebp
	roll $5, %edx
	addl %ecx, %edx

# Subround 43
	xorl $-1, %ebp
	orl %edx, %ebp
	movl 48(%esp), %esi
	xorl %eax, %ebp
	addl %esi, %ecx
	roll $10, %edi
	leal 1836072691(%ecx,%ebp,1), %ecx
	movl %edx, %ebp
	roll $14, %ecx
	addl %ebx, %ecx

# Subround 44
	xorl $-1, %ebp
	orl %ecx, %ebp
	movl 80(%esp), %esi
	xorl %edi, %ebp
	addl %esi, %ebx
	roll $10, %edx
	leal 1836072691(%ebx,%ebp,1), %ebx
	movl %ecx, %ebp
	roll $13, %ebx
	addl %eax, %ebx

# Subround 45
	xorl $-1, %ebp
	orl %ebx, %ebp
	movl 40(%esp), %esi
	xorl %edx, %ebp
	addl %esi, %eax
	roll $10, %ecx
	leal 1836072691(%eax,%ebp,1), %eax
	movl %ebx, %ebp
	roll $13, %eax
	addl %edi, %eax

# Subround 46
	xorl $-1, %ebp
	orl %eax, %ebp
	movl 56(%esp), %esi
	xorl %ecx, %ebp
	addl %esi, %edi
	roll $10, %ebx
	leal 1836072691(%edi,%ebp,1), %edi
	movl %eax, %ebp
	roll $7, %edi
	addl %edx, %edi

# Subround 47
	xorl $-1, %ebp
	orl %edi, %ebp
	movl 92(%esp), %esi
	xorl %ebx, %ebp
	addl %esi, %edx
	roll $10, %eax
	leal 1836072691(%edx,%ebp,1), %edx
	movl %edi, %ebp
	roll $5, %edx
	addl %ecx, %edx

# Subround 48
	xorl %eax, %ebp
	andl %edx, %ebp
	movl 72(%esp), %esi
	xorl %eax, %ebp
	addl %esi, %ecx
	roll $10, %edi
	leal 2053994217(%ecx,%ebp,1), %ecx
	movl %edx, %ebp
	roll $15, %ecx
	addl %ebx, %ecx

# Subround 49
	xorl %edi, %ebp
	andl %ecx, %ebp
	movl 64(%esp), %esi
	xorl %edi, %ebp
	addl %esi, %ebx
	roll $10, %edx
	leal 2053994217(%ebx,%ebp,1), %ebx
	movl %ecx, %ebp
	roll $5, %ebx
	addl %eax, %ebx

# Subround 50
	xorl %edx, %ebp
	andl %ebx, %ebp
	movl 56(%esp), %esi
	xorl %edx, %ebp
	addl %esi, %eax
	roll $10, %ecx
	leal 2053994217(%eax,%ebp,1), %eax
	movl %ebx, %ebp
	roll $8, %eax
	addl %edi, %eax

# Subround 51
	xorl %ecx, %ebp
	andl %eax, %ebp
	movl 44(%esp), %esi
	xorl %ecx, %ebp
	addl %esi, %edi
	roll $10, %ebx
	leal 2053994217(%edi,%ebp,1), %edi
	movl %eax, %ebp
	roll $11, %edi
	addl %edx, %edi

# Subround 52
	xorl %ebx, %ebp
	andl %edi, %ebp
	movl 52(%esp), %esi
	xorl %ebx, %ebp
	addl %esi, %edx
	roll $10, %eax
	leal 2053994217(%edx,%ebp,1), %edx
	movl %edi, %ebp
	roll $14, %edx
	addl %ecx, %edx

# Subround 53
	xorl %eax, %ebp
	andl %edx, %ebp
	movl 84(%esp), %esi
	xorl %eax, %ebp
	addl %esi, %ecx
	roll $10, %edi
	leal 2053994217(%ecx,%ebp,1), %ecx
	movl %edx, %ebp
	roll $14, %ecx
	addl %ebx, %ecx

# Subround 54
	xorl %edi, %ebp
	andl %ecx, %ebp
	movl 100(%esp), %esi
	xorl %edi, %ebp
	addl %esi, %ebx
	roll $10, %edx
	leal 2053994217(%ebx,%ebp,1), %ebx
	movl %ecx, %ebp
	roll $6, %ebx
	addl %eax, %ebx

# Subround 55
	xorl %edx, %ebp
	andl %ebx, %ebp
	movl 40(%esp), %esi
	xorl %edx, %ebp
	addl %esi, %eax
	roll $10, %ecx
	leal 2053994217(%eax,%ebp,1), %eax
	movl %ebx, %ebp
	roll $14, %eax
	addl %edi, %eax

# Subround 56
	xorl %ecx, %ebp
	andl %eax, %ebp
	movl 60(%esp), %esi
	xorl %ecx, %ebp
	addl %esi, %edi
	roll $10, %ebx
	leal 2053994217(%edi,%ebp,1), %edi
	movl %eax, %ebp
	roll $6, %edi
	addl %edx, %edi

# Subround 57
	xorl %ebx, %ebp
	andl %edi, %ebp
	movl 88(%esp), %esi
	xorl %ebx, %ebp
	addl %esi, %edx
	roll $10, %eax
	leal 2053994217(%edx,%ebp,1), %edx
	movl %edi, %ebp
	roll $9, %edx
	addl %ecx, %edx

# Subround 58
	xorl %eax, %ebp
	andl %edx, %ebp
	movl 48(%esp), %esi
	xorl %eax, %ebp
	addl %esi, %ecx
	roll $10, %edi
	leal 2053994217(%ecx,%ebp,1), %ecx
	movl %edx, %ebp
	roll $12, %ecx
	addl %ebx, %ecx

# Subround 59
	xorl %edi, %ebp
	andl %ecx, %ebp
	movl 92(%esp), %esi
	xorl %edi, %ebp
	addl %esi, %ebx
	roll $10, %edx
	leal 2053994217(%ebx,%ebp,1), %ebx
	movl %ecx, %ebp
	roll $9, %ebx
	addl %eax, %ebx

# Subround 60
	xorl %edx, %ebp
	andl %ebx, %ebp
	movl 76(%esp), %esi
	xorl %edx, %ebp
	addl %esi, %eax
	roll $10, %ecx
	leal 2053994217(%eax,%ebp,1), %eax
	movl %ebx, %ebp
	roll $12, %eax
	addl %edi, %eax

# Subround 61
	xorl %ecx, %ebp
	andl %eax, %ebp
	movl 68(%esp), %esi
	xorl %ecx, %ebp
	addl %esi, %edi
	roll $10, %ebx
	leal 2053994217(%edi,%ebp,1), %edi
	movl %eax, %ebp
	roll $5, %edi
	addl %edx, %edi

# Subround 62
	xorl %ebx, %ebp
	andl %edi, %ebp
	movl 80(%esp), %esi
	xorl %ebx, %ebp
	addl %esi, %edx
	roll $10, %eax
	leal 2053994217(%edx,%ebp,1), %edx
	movl %edi, %ebp
	roll $15, %edx
	addl %ecx, %edx

# Subround 63
	xorl %eax, %ebp
	andl %edx, %ebp
	movl 96(%esp), %esi
	xorl %eax, %ebp
	addl %esi, %ecx
	roll $10, %edi
	leal 2053994217(%ecx,%ebp,1), %ecx
	movl %edx, %ebp
	roll $8, %ecx
	addl %ebx, %ecx

	movl 88(%esp), %esi
# Subround 64
	xorl %edi, %ebp
	xorl %ecx, %ebp
	addl %esi, %ebx
	roll $10, %edx
	addl %ebp, %ebx
	movl %ecx, %ebp
	roll $8, %ebx
	movl 100(%esp), %esi
	addl %eax, %ebx

# Subround 65
	xorl %edx, %ebp
	addl %esi, %eax
	xorl %ebx, %ebp
	movl 80(%esp), %esi
	roll $10, %ecx
	addl %ebp, %eax
	movl %ebx, %ebp
	roll $5, %eax
	addl %edi, %eax

# Subround 66
	xorl %ecx, %ebp
	xorl %eax, %ebp
	addl %esi, %edi
	roll $10, %ebx
	addl %ebp, %edi
	movl %eax, %ebp
	roll $12, %edi
	movl 56(%esp), %esi
	addl %edx, %edi

# Subround 67
	xorl %ebx, %ebp
	addl %esi, %edx
	xorl %edi, %ebp
	movl 44(%esp), %esi
	roll $10, %eax
	addl %ebp, %edx
	movl %edi, %ebp
	roll $9, %edx
	addl %ecx, %edx

# Subround 68
	xorl %eax, %ebp
	xorl %edx, %ebp
	addl %esi, %ecx
	roll $10, %edi
	addl %ebp, %ecx
	movl %edx, %ebp
	roll $12, %ecx
	movl 60(%esp), %esi
	addl %ebx, %ecx

# Subround 69
	xorl %edi, %ebp
	addl %esi, %ebx
	xorl %ecx, %ebp
	movl 72(%esp), %esi
	roll $10, %edx
	addl %ebp, %ebx
	movl %ecx, %ebp
	roll $5, %ebx
	addl %eax, %ebx

# Subround 70
	xorl %edx, %ebp
	xorl %ebx, %ebp
	addl %esi, %eax
	roll $10, %ecx
	addl %ebp, %eax
	movl %ebx, %ebp
	roll $14, %eax
	movl 68(%esp), %esi
	addl %edi, %eax

# Subround 71
	xorl %ecx, %ebp
	addl %esi, %edi
	xorl %eax, %ebp
	movl 64(%esp), %esi
	roll $10, %ebx
	addl %ebp, %edi
	movl %eax, %ebp
	roll $6, %edi
	addl %edx, %edi

# Subround 72
	xorl %ebx, %ebp
	xorl %edi, %ebp
	addl %esi, %edx
	roll $10, %eax
	addl %ebp, %edx
	movl %edi, %ebp
	roll $8, %edx
	movl 48(%esp), %esi
	addl %ecx, %edx

# Subround 73
	xorl %eax, %ebp
	addl %esi, %ecx
	xorl %edx, %ebp
	movl 92(%esp), %esi
	roll $10, %edi
	addl %ebp, %ecx
	movl %edx, %ebp
	roll $13, %ecx
	addl %ebx, %ecx

# Subround 74
	xorl %edi, %ebp
	xorl %ecx, %ebp
	addl %esi, %ebx
	roll $10, %edx
	addl %ebp, %ebx
	movl %ecx, %ebp
	roll $6, %ebx
	movl 96(%esp), %esi
	addl %eax, %ebx

# Subround 75
	xorl %edx, %ebp
	addl %esi, %eax
	xorl %ebx, %ebp
	movl 40(%esp), %esi
	roll $10, %ecx
	addl %ebp, %eax
	movl %ebx, %ebp
	roll $5, %eax
	addl %edi, %eax

# Subround 76
	xorl %ecx, %ebp
	xorl %eax, %ebp
	addl %esi, %edi
	roll $10, %ebx
	addl %ebp, %edi
	movl %eax, %ebp
	roll $15, %edi
	movl 52(%esp), %esi
	addl %edx, %edi

# Subround 77
	xorl %ebx, %ebp
	addl %esi, %edx
	xorl %edi, %ebp
	movl 76(%esp), %esi
	roll $10, %eax
	addl %ebp, %edx
	movl %edi, %ebp
	roll $13, %edx
	addl %ecx, %edx

# Subround 78
	xorl %eax, %ebp
	xorl %edx, %ebp
	addl %esi, %ecx
	roll $10, %edi
	addl %ebp, %ecx
	movl %edx, %ebp
	roll $11, %ecx
	movl 84(%esp), %esi
	addl %ebx, %ecx

# Subround 79
	xorl %edi, %ebp
	addl %esi, %ebx
	xorl %ecx, %ebp
	roll $10, %edx
	addl %ebp, %ebx
	movl %ecx, %ebp
	roll $11, %ebx
	addl %eax, %ebx

# combine
	pushl %ecx
	movl 12(%esp), %esi
	movl 20(%esp), %ecx
	addl %eax, %ecx
	movl %esi, %eax
	movl 28(%esp), %esi
	movl 36(%esp), %ebp
	addl %esi, %eax
	addl %ebp, %ecx
	addl %edx, %eax
	movl 4(%esp), %ebp
	movl %ebx, %edx
	movl 16(%esp), %esi
	movl %edi, %ebx
	addl %ebp, %edx
	addl %esi, %ebx
	movl 32(%esp), %ebp
	addl %ebp, %ebx
	movl 40(%esp), %ebp
	addl %ebp, %edx
	movl (%esp), %edi
	addl 8(%esp), %edi
	movl 24(%esp), %ebp
	addl %ebp, %edi
	addl $44, %esp
	movl 84(%esp), %esi
	addl $64, %esp
	movl %eax, (%esi)
	movl %ebx, 4(%esi)
	movl %ecx, 8(%esi)
	movl %edx, 12(%esi)
	movl %edi, 16(%esi)

	popl %ebx
	popl %edi
	popl %esi
	popl %ebp

	ret
