#include "asm.h"
.text
.globl FUNCTION(MD5Transform)
.align ALIGN
FUNCTION(MD5Transform)

	pushl %ebp
	pushl %esi
	pushl %edi
	pushl %ebx
	movl 20(%esp), %edi
	movl 24(%esp), %esi

	movl (%edi), %eax
	movl 4(%edi), %ebx
	movl 8(%edi), %ecx
	movl 12(%edi), %edx
	movl %ecx, %edi
	movl (%esi), %ebp
# Subround 0
	xorl %edx, %edi
	andl %ebx, %edi
	leal -680876936(%eax,%ebp,1), %eax
	xorl %edx, %edi
	movl 4(%esi), %ebp
	addl %edi, %eax
	movl %ebx, %edi
	roll $7, %eax
	addl %ebx, %eax

# Subround 1
	xorl %ecx, %edi
	andl %eax, %edi
	leal -389564586(%edx,%ebp,1), %edx
	xorl %ecx, %edi
	movl 8(%esi), %ebp
	addl %edi, %edx
	movl %eax, %edi
	roll $12, %edx
	addl %eax, %edx

# Subround 2
	xorl %ebx, %edi
	andl %edx, %edi
	leal 606105819(%ecx,%ebp,1), %ecx
	xorl %ebx, %edi
	movl 12(%esi), %ebp
	addl %edi, %ecx
	movl %edx, %edi
	roll $17, %ecx
	addl %edx, %ecx

# Subround 3
	xorl %eax, %edi
	andl %ecx, %edi
	leal -1044525330(%ebx,%ebp,1), %ebx
	xorl %eax, %edi
	movl 16(%esi), %ebp
	addl %edi, %ebx
	movl %ecx, %edi
	roll $22, %ebx
	addl %ecx, %ebx

# Subround 4
	xorl %edx, %edi
	andl %ebx, %edi
	leal -176418897(%eax,%ebp,1), %eax
	xorl %edx, %edi
	movl 20(%esi), %ebp
	addl %edi, %eax
	movl %ebx, %edi
	roll $7, %eax
	addl %ebx, %eax

# Subround 5
	xorl %ecx, %edi
	andl %eax, %edi
	leal 1200080426(%edx,%ebp,1), %edx
	xorl %ecx, %edi
	movl 24(%esi), %ebp
	addl %edi, %edx
	movl %eax, %edi
	roll $12, %edx
	addl %eax, %edx

# Subround 6
	xorl %ebx, %edi
	andl %edx, %edi
	leal -1473231341(%ecx,%ebp,1), %ecx
	xorl %ebx, %edi
	movl 28(%esi), %ebp
	addl %edi, %ecx
	movl %edx, %edi
	roll $17, %ecx
	addl %edx, %ecx

# Subround 7
	xorl %eax, %edi
	andl %ecx, %edi
	leal -45705983(%ebx,%ebp,1), %ebx
	xorl %eax, %edi
	movl 32(%esi), %ebp
	addl %edi, %ebx
	movl %ecx, %edi
	roll $22, %ebx
	addl %ecx, %ebx

# Subround 8
	xorl %edx, %edi
	andl %ebx, %edi
	leal 1770035416(%eax,%ebp,1), %eax
	xorl %edx, %edi
	movl 36(%esi), %ebp
	addl %edi, %eax
	movl %ebx, %edi
	roll $7, %eax
	addl %ebx, %eax

# Subround 9
	xorl %ecx, %edi
	andl %eax, %edi
	leal -1958414417(%edx,%ebp,1), %edx
	xorl %ecx, %edi
	movl 40(%esi), %ebp
	addl %edi, %edx
	movl %eax, %edi
	roll $12, %edx
	addl %eax, %edx

# Subround 10
	xorl %ebx, %edi
	andl %edx, %edi
	leal -42063(%ecx,%ebp,1), %ecx
	xorl %ebx, %edi
	movl 44(%esi), %ebp
	addl %edi, %ecx
	movl %edx, %edi
	roll $17, %ecx
	addl %edx, %ecx

# Subround 11
	xorl %eax, %edi
	andl %ecx, %edi
	leal -1990404162(%ebx,%ebp,1), %ebx
	xorl %eax, %edi
	movl 48(%esi), %ebp
	addl %edi, %ebx
	movl %ecx, %edi
	roll $22, %ebx
	addl %ecx, %ebx

# Subround 12
	xorl %edx, %edi
	andl %ebx, %edi
	leal 1804603682(%eax,%ebp,1), %eax
	xorl %edx, %edi
	movl 52(%esi), %ebp
	addl %edi, %eax
	movl %ebx, %edi
	roll $7, %eax
	addl %ebx, %eax

# Subround 13
	xorl %ecx, %edi
	andl %eax, %edi
	leal -40341101(%edx,%ebp,1), %edx
	xorl %ecx, %edi
	movl 56(%esi), %ebp
	addl %edi, %edx
	movl %eax, %edi
	roll $12, %edx
	addl %eax, %edx

# Subround 14
	xorl %ebx, %edi
	andl %edx, %edi
	leal -1502002290(%ecx,%ebp,1), %ecx
	xorl %ebx, %edi
	movl 60(%esi), %ebp
	addl %edi, %ecx
	movl %edx, %edi
	roll $17, %ecx
	addl %edx, %ecx

# Subround 15
	xorl %eax, %edi
	andl %ecx, %edi
	leal 1236535329(%ebx,%ebp,1), %ebx
	xorl %eax, %edi
	movl 4(%esi), %ebp
	addl %edi, %ebx
	movl %ecx, %edi
	roll $22, %ebx
	addl %ecx, %ebx

# Subround 16
	xorl %ebx, %edi
	andl %edx, %edi
	leal -165796510(%eax,%ebp,1), %eax
	xorl %ecx, %edi
	movl 24(%esi), %ebp
	addl %edi, %eax
	movl %ebx, %edi
	roll $5, %eax
	addl %ebx, %eax

# Subround 17
	xorl %eax, %edi
	andl %ecx, %edi
	leal -1069501632(%edx,%ebp,1), %edx
	xorl %ebx, %edi
	movl 44(%esi), %ebp
	addl %edi, %edx
	movl %eax, %edi
	roll $9, %edx
	addl %eax, %edx

# Subround 18
	xorl %edx, %edi
	andl %ebx, %edi
	leal 643717713(%ecx,%ebp,1), %ecx
	xorl %eax, %edi
	movl (%esi), %ebp
	addl %edi, %ecx
	movl %edx, %edi
	roll $14, %ecx
	addl %edx, %ecx

# Subround 19
	xorl %ecx, %edi
	andl %eax, %edi
	leal -373897302(%ebx,%ebp,1), %ebx
	xorl %edx, %edi
	movl 20(%esi), %ebp
	addl %edi, %ebx
	movl %ecx, %edi
	roll $20, %ebx
	addl %ecx, %ebx

# Subround 20
	xorl %ebx, %edi
	andl %edx, %edi
	leal -701558691(%eax,%ebp,1), %eax
	xorl %ecx, %edi
	movl 40(%esi), %ebp
	addl %edi, %eax
	movl %ebx, %edi
	roll $5, %eax
	addl %ebx, %eax

# Subround 21
	xorl %eax, %edi
	andl %ecx, %edi
	leal 38016083(%edx,%ebp,1), %edx
	xorl %ebx, %edi
	movl 60(%esi), %ebp
	addl %edi, %edx
	movl %eax, %edi
	roll $9, %edx
	addl %eax, %edx

# Subround 22
	xorl %edx, %edi
	andl %ebx, %edi
	leal -660478335(%ecx,%ebp,1), %ecx
	xorl %eax, %edi
	movl 16(%esi), %ebp
	addl %edi, %ecx
	movl %edx, %edi
	roll $14, %ecx
	addl %edx, %ecx

# Subround 23
	xorl %ecx, %edi
	andl %eax, %edi
	leal -405537848(%ebx,%ebp,1), %ebx
	xorl %edx, %edi
	movl 36(%esi), %ebp
	addl %edi, %ebx
	movl %ecx, %edi
	roll $20, %ebx
	addl %ecx, %ebx

# Subround 24
	xorl %ebx, %edi
	andl %edx, %edi
	leal 568446438(%eax,%ebp,1), %eax
	xorl %ecx, %edi
	movl 56(%esi), %ebp
	addl %edi, %eax
	movl %ebx, %edi
	roll $5, %eax
	addl %ebx, %eax

# Subround 25
	xorl %eax, %edi
	andl %ecx, %edi
	leal -1019803690(%edx,%ebp,1), %edx
	xorl %ebx, %edi
	movl 12(%esi), %ebp
	addl %edi, %edx
	movl %eax, %edi
	roll $9, %edx
	addl %eax, %edx

# Subround 26
	xorl %edx, %edi
	andl %ebx, %edi
	leal -187363961(%ecx,%ebp,1), %ecx
	xorl %eax, %edi
	movl 32(%esi), %ebp
	addl %edi, %ecx
	movl %edx, %edi
	roll $14, %ecx
	addl %edx, %ecx

# Subround 27
	xorl %ecx, %edi
	andl %eax, %edi
	leal 1163531501(%ebx,%ebp,1), %ebx
	xorl %edx, %edi
	movl 52(%esi), %ebp
	addl %edi, %ebx
	movl %ecx, %edi
	roll $20, %ebx
	addl %ecx, %ebx

# Subround 28
	xorl %ebx, %edi
	andl %edx, %edi
	leal -1444681467(%eax,%ebp,1), %eax
	xorl %ecx, %edi
	movl 8(%esi), %ebp
	addl %edi, %eax
	movl %ebx, %edi
	roll $5, %eax
	addl %ebx, %eax

# Subround 29
	xorl %eax, %edi
	andl %ecx, %edi
	leal -51403784(%edx,%ebp,1), %edx
	xorl %ebx, %edi
	movl 28(%esi), %ebp
	addl %edi, %edx
	movl %eax, %edi
	roll $9, %edx
	addl %eax, %edx

# Subround 30
	xorl %edx, %edi
	andl %ebx, %edi
	leal 1735328473(%ecx,%ebp,1), %ecx
	xorl %eax, %edi
	movl 48(%esi), %ebp
	addl %edi, %ecx
	movl %edx, %edi
	roll $14, %ecx
	addl %edx, %ecx

# Subround 31
	xorl %ecx, %edi
	andl %eax, %edi
	leal -1926607734(%ebx,%ebp,1), %ebx
	xorl %edx, %edi
	movl 20(%esi), %ebp
	addl %edi, %ebx
	movl %ecx, %edi
	roll $20, %ebx
	addl %ecx, %ebx

# Subround 32
	xorl %edx, %edi
	xorl %ebx, %edi
	leal -378558(%eax,%ebp,1), %eax
	addl %edi, %eax
	movl 32(%esi), %ebp
	roll $4, %eax
	addl %ebx, %eax
	movl %ebx, %edi

# Subround 33
	xorl %ecx, %edi
	leal -2022574463(%edx,%ebp,1), %edx
	xorl %eax, %edi
	movl 44(%esi), %ebp
	addl %edi, %edx
	movl %eax, %edi
	roll $11, %edx
	addl %eax, %edx

# Subround 34
	xorl %ebx, %edi
	xorl %edx, %edi
	leal 1839030562(%ecx,%ebp,1), %ecx
	addl %edi, %ecx
	movl 56(%esi), %ebp
	roll $16, %ecx
	addl %edx, %ecx
	movl %edx, %edi

# Subround 35
	xorl %eax, %edi
	leal -35309556(%ebx,%ebp,1), %ebx
	xorl %ecx, %edi
	movl 4(%esi), %ebp
	addl %edi, %ebx
	movl %ecx, %edi
	roll $23, %ebx
	addl %ecx, %ebx

# Subround 36
	xorl %edx, %edi
	xorl %ebx, %edi
	leal -1530992060(%eax,%ebp,1), %eax
	addl %edi, %eax
	movl 16(%esi), %ebp
	roll $4, %eax
	addl %ebx, %eax
	movl %ebx, %edi

# Subround 37
	xorl %ecx, %edi
	leal 1272893353(%edx,%ebp,1), %edx
	xorl %eax, %edi
	movl 28(%esi), %ebp
	addl %edi, %edx
	movl %eax, %edi
	roll $11, %edx
	addl %eax, %edx

# Subround 38
	xorl %ebx, %edi
	xorl %edx, %edi
	leal -155497632(%ecx,%ebp,1), %ecx
	addl %edi, %ecx
	movl 40(%esi), %ebp
	roll $16, %ecx
	addl %edx, %ecx
	movl %edx, %edi

# Subround 39
	xorl %eax, %edi
	leal -1094730640(%ebx,%ebp,1), %ebx
	xorl %ecx, %edi
	movl 52(%esi), %ebp
	addl %edi, %ebx
	movl %ecx, %edi
	roll $23, %ebx
	addl %ecx, %ebx

# Subround 40
	xorl %edx, %edi
	xorl %ebx, %edi
	leal 681279174(%eax,%ebp,1), %eax
	addl %edi, %eax
	movl (%esi), %ebp
	roll $4, %eax
	addl %ebx, %eax
	movl %ebx, %edi

# Subround 41
	xorl %ecx, %edi
	leal -358537222(%edx,%ebp,1), %edx
	xorl %eax, %edi
	movl 12(%esi), %ebp
	addl %edi, %edx
	movl %eax, %edi
	roll $11, %edx
	addl %eax, %edx

# Subround 42
	xorl %ebx, %edi
	xorl %edx, %edi
	leal -722521979(%ecx,%ebp,1), %ecx
	addl %edi, %ecx
	movl 24(%esi), %ebp
	roll $16, %ecx
	addl %edx, %ecx
	movl %edx, %edi

# Subround 43
	xorl %eax, %edi
	leal 76029189(%ebx,%ebp,1), %ebx
	xorl %ecx, %edi
	movl 36(%esi), %ebp
	addl %edi, %ebx
	movl %ecx, %edi
	roll $23, %ebx
	addl %ecx, %ebx

# Subround 44
	xorl %edx, %edi
	xorl %ebx, %edi
	leal -640364487(%eax,%ebp,1), %eax
	addl %edi, %eax
	movl 48(%esi), %ebp
	roll $4, %eax
	addl %ebx, %eax
	movl %ebx, %edi

# Subround 45
	xorl %ecx, %edi
	leal -421815835(%edx,%ebp,1), %edx
	xorl %eax, %edi
	movl 60(%esi), %ebp
	addl %edi, %edx
	movl %eax, %edi
	roll $11, %edx
	addl %eax, %edx

# Subround 46
	xorl %ebx, %edi
	xorl %edx, %edi
	leal 530742520(%ecx,%ebp,1), %ecx
	addl %edi, %ecx
	movl 8(%esi), %ebp
	roll $16, %ecx
	addl %edx, %ecx
	movl %edx, %edi

# Subround 47
	xorl %eax, %edi
	leal -995338651(%ebx,%ebp,1), %ebx
	xorl %ecx, %edi
	movl (%esi), %ebp
	addl %edi, %ebx
	movl %edx, %edi
	roll $23, %ebx
	addl %ecx, %ebx

	nop
# Subround 48
	xorl $-1, %edi
	orl %ebx, %edi
	leal -198630844(%eax,%ebp,1), %eax
	xorl %ecx, %edi
	movl 28(%esi), %ebp
	addl %edi, %eax
	movl %ecx, %edi
	roll $6, %eax
	addl %ebx, %eax

# Subround 49
	xorl $-1, %edi
	orl %eax, %edi
	leal 1126891415(%edx,%ebp,1), %edx
	xorl %ebx, %edi
	movl 56(%esi), %ebp
	addl %edi, %edx
	movl %ebx, %edi
	roll $10, %edx
	addl %eax, %edx

# Subround 50
	xorl $-1, %edi
	orl %edx, %edi
	leal -1416354905(%ecx,%ebp,1), %ecx
	xorl %eax, %edi
	movl 20(%esi), %ebp
	addl %edi, %ecx
	movl %eax, %edi
	roll $15, %ecx
	addl %edx, %ecx

# Subround 51
	xorl $-1, %edi
	orl %ecx, %edi
	leal -57434055(%ebx,%ebp,1), %ebx
	xorl %edx, %edi
	movl 48(%esi), %ebp
	addl %edi, %ebx
	movl %edx, %edi
	roll $21, %ebx
	addl %ecx, %ebx

# Subround 52
	xorl $-1, %edi
	orl %ebx, %edi
	leal 1700485571(%eax,%ebp,1), %eax
	xorl %ecx, %edi
	movl 12(%esi), %ebp
	addl %edi, %eax
	movl %ecx, %edi
	roll $6, %eax
	addl %ebx, %eax

# Subround 53
	xorl $-1, %edi
	orl %eax, %edi
	leal -1894986606(%edx,%ebp,1), %edx
	xorl %ebx, %edi
	movl 40(%esi), %ebp
	addl %edi, %edx
	movl %ebx, %edi
	roll $10, %edx
	addl %eax, %edx

# Subround 54
	xorl $-1, %edi
	orl %edx, %edi
	leal -1051523(%ecx,%ebp,1), %ecx
	xorl %eax, %edi
	movl 4(%esi), %ebp
	addl %edi, %ecx
	movl %eax, %edi
	roll $15, %ecx
	addl %edx, %ecx

# Subround 55
	xorl $-1, %edi
	orl %ecx, %edi
	leal -2054922799(%ebx,%ebp,1), %ebx
	xorl %edx, %edi
	movl 32(%esi), %ebp
	addl %edi, %ebx
	movl %edx, %edi
	roll $21, %ebx
	addl %ecx, %ebx

# Subround 56
	xorl $-1, %edi
	orl %ebx, %edi
	leal 1873313359(%eax,%ebp,1), %eax
	xorl %ecx, %edi
	movl 60(%esi), %ebp
	addl %edi, %eax
	movl %ecx, %edi
	roll $6, %eax
	addl %ebx, %eax

# Subround 57
	xorl $-1, %edi
	orl %eax, %edi
	leal -30611744(%edx,%ebp,1), %edx
	xorl %ebx, %edi
	movl 24(%esi), %ebp
	addl %edi, %edx
	movl %ebx, %edi
	roll $10, %edx
	addl %eax, %edx

# Subround 58
	xorl $-1, %edi
	orl %edx, %edi
	leal -1560198380(%ecx,%ebp,1), %ecx
	xorl %eax, %edi
	movl 52(%esi), %ebp
	addl %edi, %ecx
	movl %eax, %edi
	roll $15, %ecx
	addl %edx, %ecx

# Subround 59
	xorl $-1, %edi
	orl %ecx, %edi
	leal 1309151649(%ebx,%ebp,1), %ebx
	xorl %edx, %edi
	movl 16(%esi), %ebp
	addl %edi, %ebx
	movl %edx, %edi
	roll $21, %ebx
	addl %ecx, %ebx

# Subround 60
	xorl $-1, %edi
	orl %ebx, %edi
	leal -145523070(%eax,%ebp,1), %eax
	xorl %ecx, %edi
	movl 44(%esi), %ebp
	addl %edi, %eax
	movl %ecx, %edi
	roll $6, %eax
	addl %ebx, %eax

# Subround 61
	xorl $-1, %edi
	orl %eax, %edi
	leal -1120210379(%edx,%ebp,1), %edx
	xorl %ebx, %edi
	movl 8(%esi), %ebp
	addl %edi, %edx
	movl %ebx, %edi
	roll $10, %edx
	addl %eax, %edx

# Subround 62
	xorl $-1, %edi
	orl %edx, %edi
	leal 718787259(%ecx,%ebp,1), %ecx
	xorl %eax, %edi
	movl 36(%esi), %ebp
	addl %edi, %ecx
	movl %eax, %edi
	roll $15, %ecx
	addl %edx, %ecx

# Subround 63
	xorl $-1, %edi
	orl %ecx, %edi
	leal -343485551(%ebx,%ebp,1), %ebx
	xorl %edx, %edi
	movl 28(%esi), %ebp
	addl %edi, %ebx
	movl %edx, %edi
	roll $21, %ebx
	addl %ecx, %ebx

	movl 20(%esp), %edi
	movl (%edi), %ebp
	movl 4(%edi), %esi
	addl %ebp, %eax
	addl %esi, %ebx
	movl %eax, (%edi)
	movl %ebx, 4(%edi)
	movl 8(%edi), %eax
	movl 12(%edi), %ebx
	addl %eax, %ecx
	addl %ebx, %edx
	movl %ecx, 8(%edi)
	movl %edx, 12(%edi)

	popl %ebx
	popl %edi
	popl %esi
	popl %ebp

	ret
