#include "asm.h"
.text
.globl FUNCTION(RIPEMD128Transform)
.align ALIGN
FUNCTION(RIPEMD128Transform)
	pushl %ebp
	pushl %esi
	pushl %edi
	pushl %ebx
	movl 20(%esp), %eax
	movl 24(%esp), %esi
	movl 12(%eax), %edx
	movl 8(%eax), %ecx
	movl 4(%eax), %ebx
	movl (%eax), %eax
	pushl %edx
	pushl %ecx
	pushl %ebx
	pushl %eax
# left half
	movl %ecx, %edi
	movl (%esi), %ebp
# Subround 0
	xorl %edx, %edi
	addl %ebp, %eax
	xorl %ebx, %edi
	movl 4(%esi), %ebp
	addl %edi, %eax
	movl %ebx, %edi
	roll $11, %eax

# Subround 1
	xorl %ecx, %edi
	addl %ebp, %edx
	xorl %eax, %edi
	movl 8(%esi), %ebp
	addl %edi, %edx
	movl %eax, %edi
	roll $14, %edx

# Subround 2
	xorl %ebx, %edi
	addl %ebp, %ecx
	xorl %edx, %edi
	movl 12(%esi), %ebp
	addl %edi, %ecx
	movl %edx, %edi
	roll $15, %ecx

# Subround 3
	xorl %eax, %edi
	addl %ebp, %ebx
	xorl %ecx, %edi
	movl 16(%esi), %ebp
	addl %edi, %ebx
	movl %ecx, %edi
	roll $12, %ebx

# Subround 4
	xorl %edx, %edi
	addl %ebp, %eax
	xorl %ebx, %edi
	movl 20(%esi), %ebp
	addl %edi, %eax
	movl %ebx, %edi
	roll $5, %eax

# Subround 5
	xorl %ecx, %edi
	addl %ebp, %edx
	xorl %eax, %edi
	movl 24(%esi), %ebp
	addl %edi, %edx
	movl %eax, %edi
	roll $8, %edx

# Subround 6
	xorl %ebx, %edi
	addl %ebp, %ecx
	xorl %edx, %edi
	movl 28(%esi), %ebp
	addl %edi, %ecx
	movl %edx, %edi
	roll $7, %ecx

# Subround 7
	xorl %eax, %edi
	addl %ebp, %ebx
	xorl %ecx, %edi
	movl 32(%esi), %ebp
	addl %edi, %ebx
	movl %ecx, %edi
	roll $9, %ebx

# Subround 8
	xorl %edx, %edi
	addl %ebp, %eax
	xorl %ebx, %edi
	movl 36(%esi), %ebp
	addl %edi, %eax
	movl %ebx, %edi
	roll $11, %eax

# Subround 9
	xorl %ecx, %edi
	addl %ebp, %edx
	xorl %eax, %edi
	movl 40(%esi), %ebp
	addl %edi, %edx
	movl %eax, %edi
	roll $13, %edx

# Subround 10
	xorl %ebx, %edi
	addl %ebp, %ecx
	xorl %edx, %edi
	movl 44(%esi), %ebp
	addl %edi, %ecx
	movl %edx, %edi
	roll $14, %ecx

# Subround 11
	xorl %eax, %edi
	addl %ebp, %ebx
	xorl %ecx, %edi
	movl 48(%esi), %ebp
	addl %edi, %ebx
	movl %ecx, %edi
	roll $15, %ebx

# Subround 12
	xorl %edx, %edi
	addl %ebp, %eax
	xorl %ebx, %edi
	movl 52(%esi), %ebp
	addl %edi, %eax
	movl %ebx, %edi
	roll $6, %eax

# Subround 13
	xorl %ecx, %edi
	addl %ebp, %edx
	xorl %eax, %edi
	movl 56(%esi), %ebp
	addl %edi, %edx
	movl %eax, %edi
	roll $7, %edx

# Subround 14
	xorl %ebx, %edi
	addl %ebp, %ecx
	xorl %edx, %edi
	movl 60(%esi), %ebp
	addl %edi, %ecx
	movl %edx, %edi
	roll $9, %ecx

# Subround 15
	xorl %eax, %edi
	addl %ebp, %ebx
	xorl %ecx, %edi
	movl 28(%esi), %ebp
	addl %edi, %ebx
	movl %ecx, %edi
	roll $8, %ebx

	xorl %edx, %edi
# Subround 16
	andl %ebx, %edi
	leal 1518500249(%eax,%ebp,1), %eax
	xorl %edx, %edi
	movl %ebx, %ebp
	addl %edi, %eax
	movl 16(%esi), %edi
	roll $7, %eax

# Subround 17
	xorl %ecx, %ebp
	leal 1518500249(%edx,%edi,1), %edx
	andl %eax, %ebp
	movl %eax, %edi
	xorl %ecx, %ebp
	xorl %ebx, %edi
	addl %ebp, %edx
	movl 52(%esi), %ebp
	roll $6, %edx

# Subround 18
	andl %edx, %edi
	leal 1518500249(%ecx,%ebp,1), %ecx
	xorl %ebx, %edi
	movl %edx, %ebp
	addl %edi, %ecx
	movl 4(%esi), %edi
	roll $8, %ecx

# Subround 19
	xorl %eax, %ebp
	leal 1518500249(%ebx,%edi,1), %ebx
	andl %ecx, %ebp
	movl %ecx, %edi
	xorl %eax, %ebp
	xorl %edx, %edi
	addl %ebp, %ebx
	movl 40(%esi), %ebp
	roll $13, %ebx

# Subround 20
	andl %ebx, %edi
	leal 1518500249(%eax,%ebp,1), %eax
	xorl %edx, %edi
	movl %ebx, %ebp
	addl %edi, %eax
	movl 24(%esi), %edi
	roll $11, %eax

# Subround 21
	xorl %ecx, %ebp
	leal 1518500249(%edx,%edi,1), %edx
	andl %eax, %ebp
	movl %eax, %edi
	xorl %ecx, %ebp
	xorl %ebx, %edi
	addl %ebp, %edx
	movl 60(%esi), %ebp
	roll $9, %edx

# Subround 22
	andl %edx, %edi
	leal 1518500249(%ecx,%ebp,1), %ecx
	xorl %ebx, %edi
	movl %edx, %ebp
	addl %edi, %ecx
	movl 12(%esi), %edi
	roll $7, %ecx

# Subround 23
	xorl %eax, %ebp
	leal 1518500249(%ebx,%edi,1), %ebx
	andl %ecx, %ebp
	movl %ecx, %edi
	xorl %eax, %ebp
	xorl %edx, %edi
	addl %ebp, %ebx
	movl 48(%esi), %ebp
	roll $15, %ebx

# Subround 24
	andl %ebx, %edi
	leal 1518500249(%eax,%ebp,1), %eax
	xorl %edx, %edi
	movl %ebx, %ebp
	addl %edi, %eax
	movl (%esi), %edi
	roll $7, %eax

# Subround 25
	xorl %ecx, %ebp
	leal 1518500249(%edx,%edi,1), %edx
	andl %eax, %ebp
	movl %eax, %edi
	xorl %ecx, %ebp
	xorl %ebx, %edi
	addl %ebp, %edx
	movl 36(%esi), %ebp
	roll $12, %edx

# Subround 26
	andl %edx, %edi
	leal 1518500249(%ecx,%ebp,1), %ecx
	xorl %ebx, %edi
	movl %edx, %ebp
	addl %edi, %ecx
	movl 20(%esi), %edi
	roll $15, %ecx

# Subround 27
	xorl %eax, %ebp
	leal 1518500249(%ebx,%edi,1), %ebx
	andl %ecx, %ebp
	movl %ecx, %edi
	xorl %eax, %ebp
	xorl %edx, %edi
	addl %ebp, %ebx
	movl 8(%esi), %ebp
	roll $9, %ebx

# Subround 28
	andl %ebx, %edi
	leal 1518500249(%eax,%ebp,1), %eax
	xorl %edx, %edi
	movl %ebx, %ebp
	addl %edi, %eax
	movl 56(%esi), %edi
	roll $11, %eax

# Subround 29
	xorl %ecx, %ebp
	leal 1518500249(%edx,%edi,1), %edx
	andl %eax, %ebp
	movl %eax, %edi
	xorl %ecx, %ebp
	xorl %ebx, %edi
	addl %ebp, %edx
	movl 44(%esi), %ebp
	roll $7, %edx

# Subround 30
	andl %edx, %edi
	leal 1518500249(%ecx,%ebp,1), %ecx
	xorl %ebx, %edi
	movl %edx, %ebp
	addl %edi, %ecx
	movl 32(%esi), %edi
	roll $13, %ecx

# Subround 31
	xorl %eax, %ebp
	leal 1518500249(%ebx,%edi,1), %ebx
	andl %ecx, %ebp
	movl %ecx, %edi
	xorl %eax, %ebp
	xorl $-1, %edi
	addl %ebp, %ebx
	movl 12(%esi), %ebp
	roll $12, %ebx

# Subround 32
	orl %ebx, %edi
	leal 1859775393(%eax,%ebp,1), %eax
	xorl %edx, %edi
	movl %ebx, %ebp
	addl %edi, %eax
	movl 40(%esi), %edi
	roll $11, %eax

# Subround 33
	xorl $-1, %ebp
	leal 1859775393(%edx,%edi,1), %edx
	orl %eax, %ebp
	movl %eax, %edi
	xorl %ecx, %ebp
	xorl $-1, %edi
	addl %ebp, %edx
	movl 56(%esi), %ebp
	roll $13, %edx

# Subround 34
	orl %edx, %edi
	leal 1859775393(%ecx,%ebp,1), %ecx
	xorl %ebx, %edi
	movl %edx, %ebp
	addl %edi, %ecx
	movl 16(%esi), %edi
	roll $6, %ecx

# Subround 35
	xorl $-1, %ebp
	leal 1859775393(%ebx,%edi,1), %ebx
	orl %ecx, %ebp
	movl %ecx, %edi
	xorl %eax, %ebp
	xorl $-1, %edi
	addl %ebp, %ebx
	movl 36(%esi), %ebp
	roll $7, %ebx

# Subround 36
	orl %ebx, %edi
	leal 1859775393(%eax,%ebp,1), %eax
	xorl %edx, %edi
	movl %ebx, %ebp
	addl %edi, %eax
	movl 60(%esi), %edi
	roll $14, %eax

# Subround 37
	xorl $-1, %ebp
	leal 1859775393(%edx,%edi,1), %edx
	orl %eax, %ebp
	movl %eax, %edi
	xorl %ecx, %ebp
	xorl $-1, %edi
	addl %ebp, %edx
	movl 32(%esi), %ebp
	roll $9, %edx

# Subround 38
	orl %edx, %edi
	leal 1859775393(%ecx,%ebp,1), %ecx
	xorl %ebx, %edi
	movl %edx, %ebp
	addl %edi, %ecx
	movl 4(%esi), %edi
	roll $13, %ecx

# Subround 39
	xorl $-1, %ebp
	leal 1859775393(%ebx,%edi,1), %ebx
	orl %ecx, %ebp
	movl %ecx, %edi
	xorl %eax, %ebp
	xorl $-1, %edi
	addl %ebp, %ebx
	movl 8(%esi), %ebp
	roll $15, %ebx

# Subround 40
	orl %ebx, %edi
	leal 1859775393(%eax,%ebp,1), %eax
	xorl %edx, %edi
	movl %ebx, %ebp
	addl %edi, %eax
	movl 28(%esi), %edi
	roll $14, %eax

# Subround 41
	xorl $-1, %ebp
	leal 1859775393(%edx,%edi,1), %edx
	orl %eax, %ebp
	movl %eax, %edi
	xorl %ecx, %ebp
	xorl $-1, %edi
	addl %ebp, %edx
	movl (%esi), %ebp
	roll $8, %edx

# Subround 42
	orl %edx, %edi
	leal 1859775393(%ecx,%ebp,1), %ecx
	xorl %ebx, %edi
	movl %edx, %ebp
	addl %edi, %ecx
	movl 24(%esi), %edi
	roll $13, %ecx

# Subround 43
	xorl $-1, %ebp
	leal 1859775393(%ebx,%edi,1), %ebx
	orl %ecx, %ebp
	movl %ecx, %edi
	xorl %eax, %ebp
	xorl $-1, %edi
	addl %ebp, %ebx
	movl 52(%esi), %ebp
	roll $6, %ebx

# Subround 44
	orl %ebx, %edi
	leal 1859775393(%eax,%ebp,1), %eax
	xorl %edx, %edi
	movl %ebx, %ebp
	addl %edi, %eax
	movl 44(%esi), %edi
	roll $5, %eax

# Subround 45
	xorl $-1, %ebp
	leal 1859775393(%edx,%edi,1), %edx
	orl %eax, %ebp
	movl %eax, %edi
	xorl %ecx, %ebp
	xorl $-1, %edi
	addl %ebp, %edx
	movl 20(%esi), %ebp
	roll $12, %edx

# Subround 46
	orl %edx, %edi
	leal 1859775393(%ecx,%ebp,1), %ecx
	xorl %ebx, %edi
	movl %edx, %ebp
	addl %edi, %ecx
	movl 48(%esi), %edi
	roll $7, %ecx

# Subround 47
	xorl $-1, %ebp
	leal 1859775393(%ebx,%edi,1), %ebx
	orl %ecx, %ebp
	movl %ecx, %edi
	xorl %eax, %ebp
	addl %ebp, %ebx
	movl 4(%esi), %ebp
	roll $5, %ebx

# Subround 48
	xorl %ebx, %edi
	movl 4(%esi), %ebp
	andl %edx, %edi
	addl %ebp, %eax
	xorl %ecx, %edi
	addl $-1894007588, %eax
	addl %edi, %eax
	movl %ebx, %edi
	roll $11, %eax

# Subround 49
	xorl %eax, %edi
	movl 36(%esi), %ebp
	andl %ecx, %edi
	addl %ebp, %edx
	xorl %ebx, %edi
	addl $-1894007588, %edx
	addl %edi, %edx
	movl %eax, %edi
	roll $12, %edx

# Subround 50
	xorl %edx, %edi
	movl 44(%esi), %ebp
	andl %ebx, %edi
	addl %ebp, %ecx
	xorl %eax, %edi
	addl $-1894007588, %ecx
	addl %edi, %ecx
	movl %edx, %edi
	roll $14, %ecx

# Subround 51
	xorl %ecx, %edi
	movl 40(%esi), %ebp
	andl %eax, %edi
	addl %ebp, %ebx
	xorl %edx, %edi
	addl $-1894007588, %ebx
	addl %edi, %ebx
	movl %ecx, %edi
	roll $15, %ebx

# Subround 52
	xorl %ebx, %edi
	movl (%esi), %ebp
	andl %edx, %edi
	addl %ebp, %eax
	xorl %ecx, %edi
	addl $-1894007588, %eax
	addl %edi, %eax
	movl %ebx, %edi
	roll $14, %eax

# Subround 53
	xorl %eax, %edi
	movl 32(%esi), %ebp
	andl %ecx, %edi
	addl %ebp, %edx
	xorl %ebx, %edi
	addl $-1894007588, %edx
	addl %edi, %edx
	movl %eax, %edi
	roll $15, %edx

# Subround 54
	xorl %edx, %edi
	movl 48(%esi), %ebp
	andl %ebx, %edi
	addl %ebp, %ecx
	xorl %eax, %edi
	addl $-1894007588, %ecx
	addl %edi, %ecx
	movl %edx, %edi
	roll $9, %ecx

# Subround 55
	xorl %ecx, %edi
	movl 16(%esi), %ebp
	andl %eax, %edi
	addl %ebp, %ebx
	xorl %edx, %edi
	addl $-1894007588, %ebx
	addl %edi, %ebx
	movl %ecx, %edi
	roll $8, %ebx

# Subround 56
	xorl %ebx, %edi
	movl 52(%esi), %ebp
	andl %edx, %edi
	addl %ebp, %eax
	xorl %ecx, %edi
	addl $-1894007588, %eax
	addl %edi, %eax
	movl %ebx, %edi
	roll $9, %eax

# Subround 57
	xorl %eax, %edi
	movl 12(%esi), %ebp
	andl %ecx, %edi
	addl %ebp, %edx
	xorl %ebx, %edi
	addl $-1894007588, %edx
	addl %edi, %edx
	movl %eax, %edi
	roll $14, %edx

# Subround 58
	xorl %edx, %edi
	movl 28(%esi), %ebp
	andl %ebx, %edi
	addl %ebp, %ecx
	xorl %eax, %edi
	addl $-1894007588, %ecx
	addl %edi, %ecx
	movl %edx, %edi
	roll $5, %ecx

# Subround 59
	xorl %ecx, %edi
	movl 60(%esi), %ebp
	andl %eax, %edi
	addl %ebp, %ebx
	xorl %edx, %edi
	addl $-1894007588, %ebx
	addl %edi, %ebx
	movl %ecx, %edi
	roll $6, %ebx

# Subround 60
	xorl %ebx, %edi
	movl 56(%esi), %ebp
	andl %edx, %edi
	addl %ebp, %eax
	xorl %ecx, %edi
	addl $-1894007588, %eax
	addl %edi, %eax
	movl %ebx, %edi
	roll $8, %eax

# Subround 61
	xorl %eax, %edi
	movl 20(%esi), %ebp
	andl %ecx, %edi
	addl %ebp, %edx
	xorl %ebx, %edi
	addl $-1894007588, %edx
	addl %edi, %edx
	movl %eax, %edi
	roll $6, %edx

# Subround 62
	xorl %edx, %edi
	movl 24(%esi), %ebp
	andl %ebx, %edi
	addl %ebp, %ecx
	xorl %eax, %edi
	addl $-1894007588, %ecx
	addl %edi, %ecx
	movl %edx, %edi
	roll $5, %ecx

# Subround 63
	xorl %ecx, %edi
	movl 8(%esi), %ebp
	andl %eax, %edi
	addl %ebp, %ebx
	xorl %edx, %edi
	addl $-1894007588, %ebx
	addl %edi, %ebx
	movl %ecx, %edi
	roll $12, %ebx

# save left result
	pushl %edx
	pushl %ecx
	pushl %ebx
	pushl %eax
# reloading chain variables
	movl 28(%esp), %edx
	movl 24(%esp), %ecx
	movl 20(%esp), %ebx
	movl 16(%esp), %eax
# right half
	movl %ecx, %edi
	movl 20(%esi), %ebp
# Subround 0
	xorl %ebx, %edi
	leal 1352829926(%eax,%ebp,1), %eax
	andl %edx, %edi
	movl %ebx, %ebp
	xorl %ecx, %edi
	nop
	addl %edi, %eax
	movl 56(%esi), %edi
	roll $8, %eax

# Subround 1
	xorl %eax, %ebp
	leal 1352829926(%edx,%edi,1), %edx
	andl %ecx, %ebp
	movl %eax, %edi
	xorl %ebx, %ebp
	nop
	addl %ebp, %edx
	movl 28(%esi), %ebp
	roll $9, %edx

# Subround 2
	xorl %edx, %edi
	leal 1352829926(%ecx,%ebp,1), %ecx
	andl %ebx, %edi
	movl %edx, %ebp
	xorl %eax, %edi
	nop
	addl %edi, %ecx
	movl (%esi), %edi
	roll $9, %ecx

# Subround 3
	xorl %ecx, %ebp
	leal 1352829926(%ebx,%edi,1), %ebx
	andl %eax, %ebp
	movl %ecx, %edi
	xorl %edx, %ebp
	nop
	addl %ebp, %ebx
	movl 36(%esi), %ebp
	roll $11, %ebx

# Subround 4
	xorl %ebx, %edi
	leal 1352829926(%eax,%ebp,1), %eax
	andl %edx, %edi
	movl %ebx, %ebp
	xorl %ecx, %edi
	nop
	addl %edi, %eax
	movl 8(%esi), %edi
	roll $13, %eax

# Subround 5
	xorl %eax, %ebp
	leal 1352829926(%edx,%edi,1), %edx
	andl %ecx, %ebp
	movl %eax, %edi
	xorl %ebx, %ebp
	nop
	addl %ebp, %edx
	movl 44(%esi), %ebp
	roll $15, %edx

# Subround 6
	xorl %edx, %edi
	leal 1352829926(%ecx,%ebp,1), %ecx
	andl %ebx, %edi
	movl %edx, %ebp
	xorl %eax, %edi
	nop
	addl %edi, %ecx
	movl 16(%esi), %edi
	roll $15, %ecx

# Subround 7
	xorl %ecx, %ebp
	leal 1352829926(%ebx,%edi,1), %ebx
	andl %eax, %ebp
	movl %ecx, %edi
	xorl %edx, %ebp
	nop
	addl %ebp, %ebx
	movl 52(%esi), %ebp
	roll $5, %ebx

# Subround 8
	xorl %ebx, %edi
	leal 1352829926(%eax,%ebp,1), %eax
	andl %edx, %edi
	movl %ebx, %ebp
	xorl %ecx, %edi
	nop
	addl %edi, %eax
	movl 24(%esi), %edi
	roll $7, %eax

# Subround 9
	xorl %eax, %ebp
	leal 1352829926(%edx,%edi,1), %edx
	andl %ecx, %ebp
	movl %eax, %edi
	xorl %ebx, %ebp
	nop
	addl %ebp, %edx
	movl 60(%esi), %ebp
	roll $7, %edx

# Subround 10
	xorl %edx, %edi
	leal 1352829926(%ecx,%ebp,1), %ecx
	andl %ebx, %edi
	movl %edx, %ebp
	xorl %eax, %edi
	nop
	addl %edi, %ecx
	movl 32(%esi), %edi
	roll $8, %ecx

# Subround 11
	xorl %ecx, %ebp
	leal 1352829926(%ebx,%edi,1), %ebx
	andl %eax, %ebp
	movl %ecx, %edi
	xorl %edx, %ebp
	nop
	addl %ebp, %ebx
	movl 4(%esi), %ebp
	roll $11, %ebx

# Subround 12
	xorl %ebx, %edi
	leal 1352829926(%eax,%ebp,1), %eax
	andl %edx, %edi
	movl %ebx, %ebp
	xorl %ecx, %edi
	nop
	addl %edi, %eax
	movl 40(%esi), %edi
	roll $14, %eax

# Subround 13
	xorl %eax, %ebp
	leal 1352829926(%edx,%edi,1), %edx
	andl %ecx, %ebp
	movl %eax, %edi
	xorl %ebx, %ebp
	nop
	addl %ebp, %edx
	movl 12(%esi), %ebp
	roll $14, %edx

# Subround 14
	xorl %edx, %edi
	leal 1352829926(%ecx,%ebp,1), %ecx
	andl %ebx, %edi
	movl %edx, %ebp
	xorl %eax, %edi
	nop
	addl %edi, %ecx
	movl 48(%esi), %edi
	roll $12, %ecx

# Subround 15
	xorl %ecx, %ebp
	leal 1352829926(%ebx,%edi,1), %ebx
	andl %eax, %ebp
	movl %ecx, %edi
	xorl %edx, %ebp
	xorl $-1, %edi
	addl %ebp, %ebx
	movl 24(%esi), %ebp
	roll $6, %ebx

# Subround 16
	orl %ebx, %edi
	leal 1548603684(%eax,%ebp,1), %eax
	xorl %edx, %edi
	movl %ebx, %ebp
	addl %edi, %eax
	movl 44(%esi), %edi
	roll $9, %eax

# Subround 17
	xorl $-1, %ebp
	leal 1548603684(%edx,%edi,1), %edx
	orl %eax, %ebp
	movl %eax, %edi
	xorl %ecx, %ebp
	xorl $-1, %edi
	addl %ebp, %edx
	movl 12(%esi), %ebp
	roll $13, %edx

# Subround 18
	orl %edx, %edi
	leal 1548603684(%ecx,%ebp,1), %ecx
	xorl %ebx, %edi
	movl %edx, %ebp
	addl %edi, %ecx
	movl 28(%esi), %edi
	roll $15, %ecx

# Subround 19
	xorl $-1, %ebp
	leal 1548603684(%ebx,%edi,1), %ebx
	orl %ecx, %ebp
	movl %ecx, %edi
	xorl %eax, %ebp
	xorl $-1, %edi
	addl %ebp, %ebx
	movl (%esi), %ebp
	roll $7, %ebx

# Subround 20
	orl %ebx, %edi
	leal 1548603684(%eax,%ebp,1), %eax
	xorl %edx, %edi
	movl %ebx, %ebp
	addl %edi, %eax
	movl 52(%esi), %edi
	roll $12, %eax

# Subround 21
	xorl $-1, %ebp
	leal 1548603684(%edx,%edi,1), %edx
	orl %eax, %ebp
	movl %eax, %edi
	xorl %ecx, %ebp
	xorl $-1, %edi
	addl %ebp, %edx
	movl 20(%esi), %ebp
	roll $8, %edx

# Subround 22
	orl %edx, %edi
	leal 1548603684(%ecx,%ebp,1), %ecx
	xorl %ebx, %edi
	movl %edx, %ebp
	addl %edi, %ecx
	movl 40(%esi), %edi
	roll $9, %ecx

# Subround 23
	xorl $-1, %ebp
	leal 1548603684(%ebx,%edi,1), %ebx
	orl %ecx, %ebp
	movl %ecx, %edi
	xorl %eax, %ebp
	xorl $-1, %edi
	addl %ebp, %ebx
	movl 56(%esi), %ebp
	roll $11, %ebx

# Subround 24
	orl %ebx, %edi
	leal 1548603684(%eax,%ebp,1), %eax
	xorl %edx, %edi
	movl %ebx, %ebp
	addl %edi, %eax
	movl 60(%esi), %edi
	roll $7, %eax

# Subround 25
	xorl $-1, %ebp
	leal 1548603684(%edx,%edi,1), %edx
	orl %eax, %ebp
	movl %eax, %edi
	xorl %ecx, %ebp
	xorl $-1, %edi
	addl %ebp, %edx
	movl 32(%esi), %ebp
	roll $7, %edx

# Subround 26
	orl %edx, %edi
	leal 1548603684(%ecx,%ebp,1), %ecx
	xorl %ebx, %edi
	movl %edx, %ebp
	addl %edi, %ecx
	movl 48(%esi), %edi
	roll $12, %ecx

# Subround 27
	xorl $-1, %ebp
	leal 1548603684(%ebx,%edi,1), %ebx
	orl %ecx, %ebp
	movl %ecx, %edi
	xorl %eax, %ebp
	xorl $-1, %edi
	addl %ebp, %ebx
	movl 16(%esi), %ebp
	roll $7, %ebx

# Subround 28
	orl %ebx, %edi
	leal 1548603684(%eax,%ebp,1), %eax
	xorl %edx, %edi
	movl %ebx, %ebp
	addl %edi, %eax
	movl 36(%esi), %edi
	roll $6, %eax

# Subround 29
	xorl $-1, %ebp
	leal 1548603684(%edx,%edi,1), %edx
	orl %eax, %ebp
	movl %eax, %edi
	xorl %ecx, %ebp
	xorl $-1, %edi
	addl %ebp, %edx
	movl 4(%esi), %ebp
	roll $15, %edx

# Subround 30
	orl %edx, %edi
	leal 1548603684(%ecx,%ebp,1), %ecx
	xorl %ebx, %edi
	movl %edx, %ebp
	addl %edi, %ecx
	movl 8(%esi), %edi
	roll $13, %ecx

# Subround 31
	xorl $-1, %ebp
	leal 1548603684(%ebx,%edi,1), %ebx
	orl %ecx, %ebp
	movl %ecx, %edi
	xorl %eax, %ebp
	xorl %edx, %edi
	addl %ebp, %ebx
	movl 60(%esi), %ebp
	roll $11, %ebx

# Subround 32
	andl %ebx, %edi
	leal 1836072691(%eax,%ebp,1), %eax
	xorl %edx, %edi
	movl %ebx, %ebp
	addl %edi, %eax
	movl 20(%esi), %edi
	roll $9, %eax

# Subround 33
	xorl %ecx, %ebp
	leal 1836072691(%edx,%edi,1), %edx
	andl %eax, %ebp
	movl %eax, %edi
	xorl %ecx, %ebp
	xorl %ebx, %edi
	addl %ebp, %edx
	movl 4(%esi), %ebp
	roll $7, %edx

# Subround 34
	andl %edx, %edi
	leal 1836072691(%ecx,%ebp,1), %ecx
	xorl %ebx, %edi
	movl %edx, %ebp
	addl %edi, %ecx
	movl 12(%esi), %edi
	roll $15, %ecx

# Subround 35
	xorl %eax, %ebp
	leal 1836072691(%ebx,%edi,1), %ebx
	andl %ecx, %ebp
	movl %ecx, %edi
	xorl %eax, %ebp
	xorl %edx, %edi
	addl %ebp, %ebx
	movl 28(%esi), %ebp
	roll $11, %ebx

# Subround 36
	andl %ebx, %edi
	leal 1836072691(%eax,%ebp,1), %eax
	xorl %edx, %edi
	movl %ebx, %ebp
	addl %edi, %eax
	movl 56(%esi), %edi
	roll $8, %eax

# Subround 37
	xorl %ecx, %ebp
	leal 1836072691(%edx,%edi,1), %edx
	andl %eax, %ebp
	movl %eax, %edi
	xorl %ecx, %ebp
	xorl %ebx, %edi
	addl %ebp, %edx
	movl 24(%esi), %ebp
	roll $6, %edx

# Subround 38
	andl %edx, %edi
	leal 1836072691(%ecx,%ebp,1), %ecx
	xorl %ebx, %edi
	movl %edx, %ebp
	addl %edi, %ecx
	movl 36(%esi), %edi
	roll $6, %ecx

# Subround 39
	xorl %eax, %ebp
	leal 1836072691(%ebx,%edi,1), %ebx
	andl %ecx, %ebp
	movl %ecx, %edi
	xorl %eax, %ebp
	xorl %edx, %edi
	addl %ebp, %ebx
	movl 44(%esi), %ebp
	roll $14, %ebx

# Subround 40
	andl %ebx, %edi
	leal 1836072691(%eax,%ebp,1), %eax
	xorl %edx, %edi
	movl %ebx, %ebp
	addl %edi, %eax
	movl 32(%esi), %edi
	roll $12, %eax

# Subround 41
	xorl %ecx, %ebp
	leal 1836072691(%edx,%edi,1), %edx
	andl %eax, %ebp
	movl %eax, %edi
	xorl %ecx, %ebp
	xorl %ebx, %edi
	addl %ebp, %edx
	movl 48(%esi), %ebp
	roll $13, %edx

# Subround 42
	andl %edx, %edi
	leal 1836072691(%ecx,%ebp,1), %ecx
	xorl %ebx, %edi
	movl %edx, %ebp
	addl %edi, %ecx
	movl 8(%esi), %edi
	roll $5, %ecx

# Subround 43
	xorl %eax, %ebp
	leal 1836072691(%ebx,%edi,1), %ebx
	andl %ecx, %ebp
	movl %ecx, %edi
	xorl %eax, %ebp
	xorl %edx, %edi
	addl %ebp, %ebx
	movl 40(%esi), %ebp
	roll $14, %ebx

# Subround 44
	andl %ebx, %edi
	leal 1836072691(%eax,%ebp,1), %eax
	xorl %edx, %edi
	movl %ebx, %ebp
	addl %edi, %eax
	movl (%esi), %edi
	roll $13, %eax

# Subround 45
	xorl %ecx, %ebp
	leal 1836072691(%edx,%edi,1), %edx
	andl %eax, %ebp
	movl %eax, %edi
	xorl %ecx, %ebp
	xorl %ebx, %edi
	addl %ebp, %edx
	movl 16(%esi), %ebp
	roll $13, %edx

# Subround 46
	andl %edx, %edi
	leal 1836072691(%ecx,%ebp,1), %ecx
	xorl %ebx, %edi
	movl %edx, %ebp
	addl %edi, %ecx
	movl 52(%esi), %edi
	roll $7, %ecx

# Subround 47
	xorl %eax, %ebp
	leal 1836072691(%ebx,%edi,1), %ebx
	andl %ecx, %ebp
	movl %ecx, %edi
	xorl %eax, %ebp
	addl %ebp, %ebx
	movl 32(%esi), %ebp
	roll $5, %ebx

# Subround 48
	xorl %edx, %edi
	addl %ebp, %eax
	xorl %ebx, %edi
	movl 24(%esi), %ebp
	addl %edi, %eax
	movl %ebx, %edi
	roll $15, %eax

# Subround 49
	xorl %ecx, %edi
	addl %ebp, %edx
	xorl %eax, %edi
	movl 16(%esi), %ebp
	addl %edi, %edx
	movl %eax, %edi
	roll $5, %edx

# Subround 50
	xorl %ebx, %edi
	addl %ebp, %ecx
	xorl %edx, %edi
	movl 4(%esi), %ebp
	addl %edi, %ecx
	movl %edx, %edi
	roll $8, %ecx

# Subround 51
	xorl %eax, %edi
	addl %ebp, %ebx
	xorl %ecx, %edi
	movl 12(%esi), %ebp
	addl %edi, %ebx
	movl %ecx, %edi
	roll $11, %ebx

# Subround 52
	xorl %edx, %edi
	addl %ebp, %eax
	xorl %ebx, %edi
	movl 44(%esi), %ebp
	addl %edi, %eax
	movl %ebx, %edi
	roll $14, %eax

# Subround 53
	xorl %ecx, %edi
	addl %ebp, %edx
	xorl %eax, %edi
	movl 60(%esi), %ebp
	addl %edi, %edx
	movl %eax, %edi
	roll $14, %edx

# Subround 54
	xorl %ebx, %edi
	addl %ebp, %ecx
	xorl %edx, %edi
	movl (%esi), %ebp
	addl %edi, %ecx
	movl %edx, %edi
	roll $6, %ecx

# Subround 55
	xorl %eax, %edi
	addl %ebp, %ebx
	xorl %ecx, %edi
	movl 20(%esi), %ebp
	addl %edi, %ebx
	movl %ecx, %edi
	roll $14, %ebx

# Subround 56
	xorl %edx, %edi
	addl %ebp, %eax
	xorl %ebx, %edi
	movl 48(%esi), %ebp
	addl %edi, %eax
	movl %ebx, %edi
	roll $6, %eax

# Subround 57
	xorl %ecx, %edi
	addl %ebp, %edx
	xorl %eax, %edi
	movl 8(%esi), %ebp
	addl %edi, %edx
	movl %eax, %edi
	roll $9, %edx

# Subround 58
	xorl %ebx, %edi
	addl %ebp, %ecx
	xorl %edx, %edi
	movl 52(%esi), %ebp
	addl %edi, %ecx
	movl %edx, %edi
	roll $12, %ecx

# Subround 59
	xorl %eax, %edi
	addl %ebp, %ebx
	xorl %ecx, %edi
	movl 36(%esi), %ebp
	addl %edi, %ebx
	movl %ecx, %edi
	roll $9, %ebx

# Subround 60
	xorl %edx, %edi
	addl %ebp, %eax
	xorl %ebx, %edi
	movl 28(%esi), %ebp
	addl %edi, %eax
	movl %ebx, %edi
	roll $12, %eax

# Subround 61
	xorl %ecx, %edi
	addl %ebp, %edx
	xorl %eax, %edi
	movl 40(%esi), %ebp
	addl %edi, %edx
	movl %eax, %edi
	roll $5, %edx

# Subround 62
	xorl %ebx, %edi
	addl %ebp, %ecx
	xorl %edx, %edi
	movl 56(%esi), %ebp
	addl %edi, %ecx
	movl %edx, %edi
	roll $15, %ecx

# Subround 63
	xorl %eax, %edi
	addl %ebp, %ebx
	xorl %ecx, %edi
	addl %edi, %ebx
	movl %ecx, %edi
	roll $8, %ebx

# combine
	pushl %ebx
	movl %edx, %edi
	movl 12(%esp), %ebp
	addl %ebp, %edi
	movl 24(%esp), %ebp
	addl %ebp, %edi
	movl %eax, %ebx
	movl %edi, %eax
	movl 16(%esp), %ebp
	addl %ebp, %ebx
	movl 28(%esp), %ebp
	addl %ebp, %ebx
	movl %ecx, %edx
	movl (%esp), %ecx
	movl 8(%esp), %ebp
	addl %ebp, %edx
	movl 20(%esp), %ebp
	addl %ebp, %edx
	movl 32(%esp), %ebp
	addl %ebp, %ecx
	movl 4(%esp), %ebp
	addl %ebp, %ecx
	addl $36, %esp
	movl 20(%esp), %edi
	movl %eax, (%edi)
	movl %ebx, 4(%edi)
	movl %ecx, 8(%edi)
	movl %edx, 12(%edi)

	popl %ebx
	popl %edi
	popl %esi
	popl %ebp

	ret
