# This software was written by Leonard Janke (janke@unixg.ubc.ca)
# in 1996-7 and is entered, by him, into the public domain.

include ../../config.gnu 
 
CHINCLUDE=-I../../include/
CHLIB=-L../../lib/ -lch
EXECUTABLES=md5$(EXESUFFIX) sha0$(EXESUFFIX) sha1$(EXESUFFIX) \
            rmd128$(EXESUFFIX) rmd160$(EXESUFFIX)

all:	$(EXECUTABLES)

%$(EXESUFFIX):	%.o
	$(LINK) $(EXENAME) $@  $(LINKFILE) $< $(CHLIB)

%.o:	%.cpp
	$(CPP) $(CPPFLAGS) $(CPPOPTIMIZE) $(CHINCLUDE) $(CPPCOMPILE) $< 

clean: 
	rm -f *~ *.o $(EXECUTABLES)

distclean:	clean
