#
# This software was written by Leonard Janke (janke@unixg.ubc.ca)
# in 1996-7 and is, hereby, entered into the public domain.

!include ..\..\config.ms
 
CHINCLUDE=/I..\..\include
CHLIB=..\..\lib\ch.lib
EXECUTABLES=md5s.exe sha1s.exe sha0s.exe rmd128s.exe rmd160s.exe

all :	$(EXECUTABLES)

.obj.exe :
	$(LINKER) $(LINKQUIET) $(CHLIB) $(LINKFILE)  $*.obj

.cpp.obj :
	$(CPP) $(CPPQUIET) $(CPPFLAGS) $(CPPOPTIMIZE) $(CHINCLUDE)  $*.cpp

sha1s.exe :	sha1s.obj

sha1s.obj :	sha1s.cpp

sha0s.exe :	sha0s.obj

sha0s.obj :	sha0s.cpp

md5s.exe :	md5s.obj

md5s.obj :	md5s.cpp

rmd128s.exe :	rmd128s.obj

rmd128s.obj :	rmd128s.cpp

rmd160s.exe :	rmd160s.obj

rmd160s.obj :	rmd160s.cpp

clean :
	if exist *~ $(DELETE) *~
	if exist *.obj $(DELETE) *.obj
	if exist *.exe $(DELETE) *.exe

distclean :	clean 
