#
# This software was written by Leonard Janke (janke@unixg.ubc.ca)
# in 1996-7 and is, hereby, entered into the public domain.

!include ..\..\config.wat
 
CHINCLUDE=/i..\..\include\
CHLIB=libpath ..\..\lib\ lib ch
EXECUTABLES=md5s.exe sha1s.exe sha0s.exe rmd128s.exe rmd160s.exe

all :	$(EXECUTABLES) .SYMBOLIC

.obj.exe :
	$(LINK) $(LINKQUIET) $(CHLIB) $(LINKFILE)  $[.

.cpp.obj :
	$(CPP) $(CPPQUIET) $(CPPFLAGS) $(CHINCLUDE)  $(CPPOPTIMIZE) $[.

sha1.exe :	sha1.obj

sha1.obj :	sha1.cpp

sha0.exe :	sha0.obj

sha0.obj :	sha0.cpp

md5.exe :	md5.obj

md5.obj :	md5.cpp

rmd128.exe :	rmd128.obj

rmd128.obj :	rmd128.cpp

rmd160.exe :	rmd160.obj

rmd160.obj :	rmd160.cpp

clean 
	@if exist *~ $(DELETE) *~
	@if exist *.obj $(DELETE) *.obj
	@if exist *.exe $(DELETE) *.exe

distclean :	clean  .SYMBOLIC
